/* Notification.c generated by valac 0.56.17, the Vala compiler
 * generated from Notification.vala, do not modify */

/*-
 * Copyright (c) 2015 Wingpanel Developers (http://launchpad.net/wingpanel)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "notifications.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gdesktopappinfo.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define NOTIFICATIONS_NOTIFICATION_X_CANONICAL_PRIVATE_KEY "x-canonical-private-synchronous"
#define NOTIFICATIONS_NOTIFICATION_DESKTOP_ENTRY_KEY "desktop-entry"
#define NOTIFICATIONS_NOTIFICATION_FALLBACK_DESKTOP_ID "gala-other" NOTIFICATIONS_NOTIFICATION_DESKTOP_ID_EXT
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	NOTIFICATIONS_NOTIFICATION_0_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_INTERNAL_ID_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_IMAGE_PATH_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_DEFAULT_ACTION_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_SERVER_ID_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_BADGE_ICON_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_NUM_PROPERTIES
};
static GParamSpec* notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_NUM_PROPERTIES];
typedef enum  {
	NOTIFICATIONS_NOTIFICATION_COLUMN_APP_NAME = 0,
	NOTIFICATIONS_NOTIFICATION_COLUMN_REPLACES_ID,
	NOTIFICATIONS_NOTIFICATION_COLUMN_APP_ICON,
	NOTIFICATIONS_NOTIFICATION_COLUMN_SUMMARY,
	NOTIFICATIONS_NOTIFICATION_COLUMN_BODY,
	NOTIFICATIONS_NOTIFICATION_COLUMN_ACTIONS,
	NOTIFICATIONS_NOTIFICATION_COLUMN_HINTS,
	NOTIFICATIONS_NOTIFICATION_COLUMN_EXPIRE_TIMEOUT,
	NOTIFICATIONS_NOTIFICATION_COLUMN_COUNT
} NotificationsNotificationColumn;

#define NOTIFICATIONS_NOTIFICATION_TYPE_COLUMN (notifications_notification_column_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NotificationsNotificationPrivate {
	gchar* _internal_id;
	gchar* _image_path;
	gchar* _default_action;
	guint32 _server_id;
	GIcon* _badge_icon;
};

static gint NotificationsNotification_private_offset;
static gpointer notifications_notification_parent_class = NULL;

static GType notifications_notification_column_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void notifications_notification_set_image_path (NotificationsNotification* self,
                                                const gchar* value);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static GList* notifications_notification_validate_actions (NotificationsNotification* self,
                                                    gchar** actions,
                                                    gint actions_length1);
static gchar* notifications_notification_get_string (NotificationsNotification* self,
                                              GVariant* tuple,
                                              gint column);
static guint32 notifications_notification_get_uint32 (NotificationsNotification* self,
                                               GVariant* tuple,
                                               gint column);
static gchar* notifications_notification_lookup_string (NotificationsNotification* self,
                                                 GVariant* tuple,
                                                 const gchar* key);
static GdkPixbuf* notifications_notification_lookup_pixbuf (NotificationsNotification* self,
                                                     GVariant* tuple,
                                                     const gchar* key);
static void notifications_notification_set_default_action (NotificationsNotification* self,
                                                    const gchar* value);
static gchar* notifications_notification_make_temp_file (NotificationsNotification* self,
                                                  const gchar* tmpl);
static void notifications_notification_finalize (GObject * obj);
static GType notifications_notification_get_type_once (void);
static void _vala_notifications_notification_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_notifications_notification_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
notifications_notification_get_instance_private (NotificationsNotification* self)
{
	return G_STRUCT_MEMBER_P (self, NotificationsNotification_private_offset);
}

static GType
notifications_notification_close_reason_get_type_once (void)
{
	static const GEnumValue values[] = {{NOTIFICATIONS_NOTIFICATION_CLOSE_REASON_EXPIRED, "NOTIFICATIONS_NOTIFICATION_CLOSE_REASON_EXPIRED", "expired"}, {NOTIFICATIONS_NOTIFICATION_CLOSE_REASON_DISMISSED, "NOTIFICATIONS_NOTIFICATION_CLOSE_REASON_DISMISSED", "dismissed"}, {NOTIFICATIONS_NOTIFICATION_CLOSE_REASON_CLOSE_NOTIFICATION_CALL, "NOTIFICATIONS_NOTIFICATION_CLOSE_REASON_CLOSE_NOTIFICATION_CALL", "close-notification-call"}, {NOTIFICATIONS_NOTIFICATION_CLOSE_REASON_UNDEFINED, "NOTIFICATIONS_NOTIFICATION_CLOSE_REASON_UNDEFINED", "undefined"}, {0, NULL, NULL}};
	GType notifications_notification_close_reason_type_id;
	notifications_notification_close_reason_type_id = g_enum_register_static ("NotificationsNotificationCloseReason", values);
	return notifications_notification_close_reason_type_id;
}

GType
notifications_notification_close_reason_get_type (void)
{
	static volatile gsize notifications_notification_close_reason_type_id__once = 0;
	if (g_once_init_enter (&notifications_notification_close_reason_type_id__once)) {
		GType notifications_notification_close_reason_type_id;
		notifications_notification_close_reason_type_id = notifications_notification_close_reason_get_type_once ();
		g_once_init_leave (&notifications_notification_close_reason_type_id__once, notifications_notification_close_reason_type_id);
	}
	return notifications_notification_close_reason_type_id__once;
}

static GType
notifications_notification_column_get_type_once (void)
{
	static const GEnumValue values[] = {{NOTIFICATIONS_NOTIFICATION_COLUMN_APP_NAME, "NOTIFICATIONS_NOTIFICATION_COLUMN_APP_NAME", "app-name"}, {NOTIFICATIONS_NOTIFICATION_COLUMN_REPLACES_ID, "NOTIFICATIONS_NOTIFICATION_COLUMN_REPLACES_ID", "replaces-id"}, {NOTIFICATIONS_NOTIFICATION_COLUMN_APP_ICON, "NOTIFICATIONS_NOTIFICATION_COLUMN_APP_ICON", "app-icon"}, {NOTIFICATIONS_NOTIFICATION_COLUMN_SUMMARY, "NOTIFICATIONS_NOTIFICATION_COLUMN_SUMMARY", "summary"}, {NOTIFICATIONS_NOTIFICATION_COLUMN_BODY, "NOTIFICATIONS_NOTIFICATION_COLUMN_BODY", "body"}, {NOTIFICATIONS_NOTIFICATION_COLUMN_ACTIONS, "NOTIFICATIONS_NOTIFICATION_COLUMN_ACTIONS", "actions"}, {NOTIFICATIONS_NOTIFICATION_COLUMN_HINTS, "NOTIFICATIONS_NOTIFICATION_COLUMN_HINTS", "hints"}, {NOTIFICATIONS_NOTIFICATION_COLUMN_EXPIRE_TIMEOUT, "NOTIFICATIONS_NOTIFICATION_COLUMN_EXPIRE_TIMEOUT", "expire-timeout"}, {NOTIFICATIONS_NOTIFICATION_COLUMN_COUNT, "NOTIFICATIONS_NOTIFICATION_COLUMN_COUNT", "count"}, {0, NULL, NULL}};
	GType notifications_notification_column_type_id;
	notifications_notification_column_type_id = g_enum_register_static ("NotificationsNotificationColumn", values);
	return notifications_notification_column_type_id;
}

static GType
notifications_notification_column_get_type (void)
{
	static volatile gsize notifications_notification_column_type_id__once = 0;
	if (g_once_init_enter (&notifications_notification_column_type_id__once)) {
		GType notifications_notification_column_type_id;
		notifications_notification_column_type_id = notifications_notification_column_get_type_once ();
		g_once_init_leave (&notifications_notification_column_type_id__once, notifications_notification_column_type_id);
	}
	return notifications_notification_column_type_id__once;
}

static void
_g_object_unref0_ (gpointer var)
{
#line 37 "../src/Services/Notification.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 181 "Notification.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 37 "../src/Services/Notification.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 189 "Notification.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 77 "../src/Services/Notification.vala"
	if (length >= 0) {
#line 198 "Notification.c"
		gchar** result;
		gssize i;
#line 77 "../src/Services/Notification.vala"
		result = g_new0 (gchar*, length + 1);
#line 77 "../src/Services/Notification.vala"
		for (i = 0; i < length; i++) {
#line 205 "Notification.c"
			gchar* _tmp0_;
#line 77 "../src/Services/Notification.vala"
			_tmp0_ = g_strdup (self[i]);
#line 77 "../src/Services/Notification.vala"
			result[i] = _tmp0_;
#line 211 "Notification.c"
		}
#line 77 "../src/Services/Notification.vala"
		return result;
#line 215 "Notification.c"
	}
#line 77 "../src/Services/Notification.vala"
	return NULL;
#line 219 "Notification.c"
}

NotificationsNotification*
notifications_notification_construct (GType object_type,
                                      const gchar* _internal_id,
                                      const gchar* _app_name,
                                      const gchar* _app_icon,
                                      const gchar* _summary,
                                      const gchar* _message_body,
                                      const gchar* _image_path,
                                      gchar** _actions,
                                      gint _actions_length1,
                                      const gchar* _desktop_id,
                                      gint64 _unix_time,
                                      guint64 _replaces_id,
                                      const gchar* _sender,
                                      gboolean _has_temp_file)
{
	NotificationsNotification * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar** _tmp6_;
	gint _tmp6__length1;
	GList* _tmp7_;
	GDateTime* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	GDesktopAppInfo* _tmp11_;
#line 64 "../src/Services/Notification.vala"
	g_return_val_if_fail (_internal_id != NULL, NULL);
#line 64 "../src/Services/Notification.vala"
	g_return_val_if_fail (_app_name != NULL, NULL);
#line 64 "../src/Services/Notification.vala"
	g_return_val_if_fail (_app_icon != NULL, NULL);
#line 64 "../src/Services/Notification.vala"
	g_return_val_if_fail (_summary != NULL, NULL);
#line 64 "../src/Services/Notification.vala"
	g_return_val_if_fail (_message_body != NULL, NULL);
#line 64 "../src/Services/Notification.vala"
	g_return_val_if_fail (_image_path != NULL, NULL);
#line 64 "../src/Services/Notification.vala"
	g_return_val_if_fail (_desktop_id != NULL, NULL);
#line 64 "../src/Services/Notification.vala"
	g_return_val_if_fail (_sender != NULL, NULL);
#line 64 "../src/Services/Notification.vala"
	self = (NotificationsNotification*) g_object_new (object_type, NULL);
#line 68 "../src/Services/Notification.vala"
	notifications_notification_set_internal_id (self, _internal_id);
#line 69 "../src/Services/Notification.vala"
	_tmp0_ = g_strdup (_app_name);
#line 69 "../src/Services/Notification.vala"
	_g_free0 (self->app_name);
#line 69 "../src/Services/Notification.vala"
	self->app_name = _tmp0_;
#line 70 "../src/Services/Notification.vala"
	_tmp1_ = g_strdup (_app_icon);
#line 70 "../src/Services/Notification.vala"
	_g_free0 (self->app_icon);
#line 70 "../src/Services/Notification.vala"
	self->app_icon = _tmp1_;
#line 71 "../src/Services/Notification.vala"
	_tmp2_ = g_strdup (_summary);
#line 71 "../src/Services/Notification.vala"
	_g_free0 (self->summary);
#line 71 "../src/Services/Notification.vala"
	self->summary = _tmp2_;
#line 72 "../src/Services/Notification.vala"
	_tmp3_ = g_strdup (_message_body);
#line 72 "../src/Services/Notification.vala"
	_g_free0 (self->message_body);
#line 72 "../src/Services/Notification.vala"
	self->message_body = _tmp3_;
#line 73 "../src/Services/Notification.vala"
	notifications_notification_set_image_path (self, _image_path);
#line 74 "../src/Services/Notification.vala"
	self->replaces_id = (guint32) _replaces_id;
#line 75 "../src/Services/Notification.vala"
	_tmp4_ = g_strdup (_sender);
#line 75 "../src/Services/Notification.vala"
	_g_free0 (self->sender);
#line 75 "../src/Services/Notification.vala"
	self->sender = _tmp4_;
#line 77 "../src/Services/Notification.vala"
	_tmp5_ = (_actions != NULL) ? _vala_array_dup1 (_actions, _actions_length1) : _actions;
#line 77 "../src/Services/Notification.vala"
	_tmp5__length1 = _actions_length1;
#line 77 "../src/Services/Notification.vala"
	self->actions = (_vala_array_free (self->actions, self->actions_length1, (GDestroyNotify) g_free), NULL);
#line 77 "../src/Services/Notification.vala"
	self->actions = _tmp5_;
#line 77 "../src/Services/Notification.vala"
	self->actions_length1 = _tmp5__length1;
#line 78 "../src/Services/Notification.vala"
	_tmp6_ = self->actions;
#line 78 "../src/Services/Notification.vala"
	_tmp6__length1 = self->actions_length1;
#line 78 "../src/Services/Notification.vala"
	_tmp7_ = notifications_notification_validate_actions (self, _tmp6_, (gint) _tmp6__length1);
#line 78 "../src/Services/Notification.vala"
	(self->buttons == NULL) ? NULL : (self->buttons = (_g_list_free__g_object_unref0_ (self->buttons), NULL));
#line 78 "../src/Services/Notification.vala"
	self->buttons = _tmp7_;
#line 80 "../src/Services/Notification.vala"
	_tmp8_ = g_date_time_new_from_unix_local (_unix_time);
#line 80 "../src/Services/Notification.vala"
	_g_date_time_unref0 (self->timestamp);
#line 80 "../src/Services/Notification.vala"
	self->timestamp = _tmp8_;
#line 82 "../src/Services/Notification.vala"
	_tmp9_ = g_strdup (_desktop_id);
#line 82 "../src/Services/Notification.vala"
	_g_free0 (self->desktop_id);
#line 82 "../src/Services/Notification.vala"
	self->desktop_id = _tmp9_;
#line 83 "../src/Services/Notification.vala"
	_tmp10_ = self->desktop_id;
#line 83 "../src/Services/Notification.vala"
	_tmp11_ = g_desktop_app_info_new (_tmp10_);
#line 83 "../src/Services/Notification.vala"
	_g_object_unref0 (self->app_info);
#line 83 "../src/Services/Notification.vala"
	self->app_info = _tmp11_;
#line 85 "../src/Services/Notification.vala"
	self->has_temp_file = _has_temp_file;
#line 64 "../src/Services/Notification.vala"
	return self;
#line 351 "Notification.c"
}

NotificationsNotification*
notifications_notification_new (const gchar* _internal_id,
                                const gchar* _app_name,
                                const gchar* _app_icon,
                                const gchar* _summary,
                                const gchar* _message_body,
                                const gchar* _image_path,
                                gchar** _actions,
                                gint _actions_length1,
                                const gchar* _desktop_id,
                                gint64 _unix_time,
                                guint64 _replaces_id,
                                const gchar* _sender,
                                gboolean _has_temp_file)
{
#line 64 "../src/Services/Notification.vala"
	return notifications_notification_construct (NOTIFICATIONS_TYPE_NOTIFICATION, _internal_id, _app_name, _app_icon, _summary, _message_body, _image_path, _actions, _actions_length1, _desktop_id, _unix_time, _replaces_id, _sender, _has_temp_file);
#line 371 "Notification.c"
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 89 "../src/Services/Notification.vala"
	return self ? g_variant_ref (self) : NULL;
#line 379 "Notification.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 401 "Notification.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 405 "Notification.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 411 "Notification.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 415 "Notification.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 419 "Notification.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 427 "Notification.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 455 "Notification.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 464 "Notification.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 478 "Notification.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 487 "Notification.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 501 "Notification.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 510 "Notification.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 519 "Notification.c"
}

NotificationsNotification*
notifications_notification_construct_from_message (GType object_type,
                                                   GDBusMessage* message,
                                                   guint32 _id)
{
	NotificationsNotification * self = NULL;
	GVariant* body = NULL;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	gchar* _tmp3_;
	GVariant* _tmp4_;
	gchar* _tmp5_;
	GVariant* _tmp6_;
	gchar* _tmp7_;
	GVariant* hints = NULL;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	GVariant* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	gsize _tmp16_ = 0;
	gchar** _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	GList* _tmp19_;
	GDateTime* _tmp20_;
	GDateTime* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	guint32 _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GVariant* _tmp31_;
	gchar* _tmp32_;
	gboolean _tmp33_ = FALSE;
	const gchar* _tmp34_;
	GVariant* _tmp41_;
	gchar* _tmp42_;
	gboolean _tmp43_ = FALSE;
	const gchar* _tmp44_;
	gboolean _tmp49_ = FALSE;
	GVariant* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	gboolean _tmp53_;
	GdkPixbuf* buf = NULL;
	gboolean _tmp73_ = FALSE;
	gboolean _tmp74_ = FALSE;
	GVariant* _tmp75_;
	GdkPixbuf* _tmp76_;
	GdkPixbuf* _tmp77_;
	GDesktopAppInfo* _tmp88_;
#line 88 "../src/Services/Notification.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 88 "../src/Services/Notification.vala"
	self = (NotificationsNotification*) g_object_new (object_type, NULL);
#line 89 "../src/Services/Notification.vala"
	_tmp0_ = g_dbus_message_get_body (message);
#line 89 "../src/Services/Notification.vala"
	_tmp1_ = _g_variant_ref0 (_tmp0_);
#line 89 "../src/Services/Notification.vala"
	body = _tmp1_;
#line 91 "../src/Services/Notification.vala"
	_tmp2_ = body;
#line 91 "../src/Services/Notification.vala"
	_tmp3_ = notifications_notification_get_string (self, _tmp2_, (gint) NOTIFICATIONS_NOTIFICATION_COLUMN_APP_NAME);
#line 91 "../src/Services/Notification.vala"
	_g_free0 (self->app_name);
#line 91 "../src/Services/Notification.vala"
	self->app_name = _tmp3_;
#line 92 "../src/Services/Notification.vala"
	_tmp4_ = body;
#line 92 "../src/Services/Notification.vala"
	_tmp5_ = notifications_notification_get_string (self, _tmp4_, (gint) NOTIFICATIONS_NOTIFICATION_COLUMN_SUMMARY);
#line 92 "../src/Services/Notification.vala"
	_g_free0 (self->summary);
#line 92 "../src/Services/Notification.vala"
	self->summary = _tmp5_;
#line 93 "../src/Services/Notification.vala"
	_tmp6_ = body;
#line 93 "../src/Services/Notification.vala"
	_tmp7_ = notifications_notification_get_string (self, _tmp6_, (gint) NOTIFICATIONS_NOTIFICATION_COLUMN_BODY);
#line 93 "../src/Services/Notification.vala"
	_g_free0 (self->message_body);
#line 93 "../src/Services/Notification.vala"
	self->message_body = _tmp7_;
#line 94 "../src/Services/Notification.vala"
	_tmp8_ = body;
#line 94 "../src/Services/Notification.vala"
	_tmp9_ = g_variant_get_child_value (_tmp8_, (gsize) NOTIFICATIONS_NOTIFICATION_COLUMN_HINTS);
#line 94 "../src/Services/Notification.vala"
	hints = _tmp9_;
#line 95 "../src/Services/Notification.vala"
	_tmp10_ = body;
#line 95 "../src/Services/Notification.vala"
	self->replaces_id = notifications_notification_get_uint32 (self, _tmp10_, (gint) NOTIFICATIONS_NOTIFICATION_COLUMN_REPLACES_ID);
#line 96 "../src/Services/Notification.vala"
	notifications_notification_set_server_id (self, _id);
#line 97 "../src/Services/Notification.vala"
	_tmp11_ = g_dbus_message_get_sender (message);
#line 97 "../src/Services/Notification.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 97 "../src/Services/Notification.vala"
	_g_free0 (self->sender);
#line 97 "../src/Services/Notification.vala"
	self->sender = _tmp12_;
#line 99 "../src/Services/Notification.vala"
	_tmp13_ = body;
#line 99 "../src/Services/Notification.vala"
	_tmp14_ = g_variant_get_child_value (_tmp13_, (gsize) NOTIFICATIONS_NOTIFICATION_COLUMN_ACTIONS);
#line 99 "../src/Services/Notification.vala"
	_tmp15_ = _tmp14_;
#line 99 "../src/Services/Notification.vala"
	_tmp17_ = g_variant_dup_strv (_tmp15_, &_tmp16_);
#line 99 "../src/Services/Notification.vala"
	self->actions = (_vala_array_free (self->actions, self->actions_length1, (GDestroyNotify) g_free), NULL);
#line 99 "../src/Services/Notification.vala"
	self->actions = _tmp17_;
#line 99 "../src/Services/Notification.vala"
	self->actions_length1 = _tmp16_;
#line 99 "../src/Services/Notification.vala"
	_g_variant_unref0 (_tmp15_);
#line 100 "../src/Services/Notification.vala"
	_tmp18_ = self->actions;
#line 100 "../src/Services/Notification.vala"
	_tmp18__length1 = self->actions_length1;
#line 100 "../src/Services/Notification.vala"
	_tmp19_ = notifications_notification_validate_actions (self, _tmp18_, (gint) _tmp18__length1);
#line 100 "../src/Services/Notification.vala"
	(self->buttons == NULL) ? NULL : (self->buttons = (_g_list_free__g_object_unref0_ (self->buttons), NULL));
#line 100 "../src/Services/Notification.vala"
	self->buttons = _tmp19_;
#line 102 "../src/Services/Notification.vala"
	_tmp20_ = g_date_time_new_now_local ();
#line 102 "../src/Services/Notification.vala"
	_g_date_time_unref0 (self->timestamp);
#line 102 "../src/Services/Notification.vala"
	self->timestamp = _tmp20_;
#line 104 "../src/Services/Notification.vala"
	_tmp21_ = self->timestamp;
#line 104 "../src/Services/Notification.vala"
	_tmp22_ = g_strdup_printf ("%" G_GINT64_FORMAT, g_date_time_to_unix (_tmp21_));
#line 104 "../src/Services/Notification.vala"
	_tmp23_ = _tmp22_;
#line 104 "../src/Services/Notification.vala"
	_tmp24_ = g_strconcat (_tmp23_, ".", NULL);
#line 104 "../src/Services/Notification.vala"
	_tmp25_ = _tmp24_;
#line 104 "../src/Services/Notification.vala"
	_tmp26_ = self->priv->_server_id;
#line 104 "../src/Services/Notification.vala"
	_tmp27_ = g_strdup_printf ("%u", _tmp26_);
#line 104 "../src/Services/Notification.vala"
	_tmp28_ = _tmp27_;
#line 104 "../src/Services/Notification.vala"
	_tmp29_ = g_strconcat (_tmp25_, _tmp28_, NULL);
#line 104 "../src/Services/Notification.vala"
	_tmp30_ = _tmp29_;
#line 104 "../src/Services/Notification.vala"
	notifications_notification_set_internal_id (self, _tmp30_);
#line 104 "../src/Services/Notification.vala"
	_g_free0 (_tmp30_);
#line 104 "../src/Services/Notification.vala"
	_g_free0 (_tmp28_);
#line 104 "../src/Services/Notification.vala"
	_g_free0 (_tmp25_);
#line 104 "../src/Services/Notification.vala"
	_g_free0 (_tmp23_);
#line 106 "../src/Services/Notification.vala"
	_tmp31_ = hints;
#line 106 "../src/Services/Notification.vala"
	_tmp32_ = notifications_notification_lookup_string (self, _tmp31_, NOTIFICATIONS_NOTIFICATION_DESKTOP_ENTRY_KEY);
#line 106 "../src/Services/Notification.vala"
	_g_free0 (self->desktop_id);
#line 106 "../src/Services/Notification.vala"
	self->desktop_id = _tmp32_;
#line 107 "../src/Services/Notification.vala"
	_tmp34_ = self->desktop_id;
#line 107 "../src/Services/Notification.vala"
	if (_tmp34_ != NULL) {
#line 710 "Notification.c"
		const gchar* _tmp35_;
#line 107 "../src/Services/Notification.vala"
		_tmp35_ = self->desktop_id;
#line 107 "../src/Services/Notification.vala"
		_tmp33_ = g_strcmp0 (_tmp35_, "") != 0;
#line 716 "Notification.c"
	} else {
#line 107 "../src/Services/Notification.vala"
		_tmp33_ = FALSE;
#line 720 "Notification.c"
	}
#line 107 "../src/Services/Notification.vala"
	if (_tmp33_) {
#line 724 "Notification.c"
		const gchar* _tmp36_;
		const gchar* _tmp39_;
		GDesktopAppInfo* _tmp40_;
#line 108 "../src/Services/Notification.vala"
		_tmp36_ = self->desktop_id;
#line 108 "../src/Services/Notification.vala"
		if (!g_str_has_suffix (_tmp36_, NOTIFICATIONS_NOTIFICATION_DESKTOP_ID_EXT)) {
#line 732 "Notification.c"
			const gchar* _tmp37_;
			gchar* _tmp38_;
#line 109 "../src/Services/Notification.vala"
			_tmp37_ = self->desktop_id;
#line 109 "../src/Services/Notification.vala"
			_tmp38_ = g_strconcat (_tmp37_, NOTIFICATIONS_NOTIFICATION_DESKTOP_ID_EXT, NULL);
#line 109 "../src/Services/Notification.vala"
			_g_free0 (self->desktop_id);
#line 109 "../src/Services/Notification.vala"
			self->desktop_id = _tmp38_;
#line 743 "Notification.c"
		}
#line 112 "../src/Services/Notification.vala"
		_tmp39_ = self->desktop_id;
#line 112 "../src/Services/Notification.vala"
		_tmp40_ = g_desktop_app_info_new (_tmp39_);
#line 112 "../src/Services/Notification.vala"
		_g_object_unref0 (self->app_info);
#line 112 "../src/Services/Notification.vala"
		self->app_info = _tmp40_;
#line 753 "Notification.c"
	}
#line 115 "../src/Services/Notification.vala"
	_tmp41_ = body;
#line 115 "../src/Services/Notification.vala"
	_tmp42_ = notifications_notification_get_string (self, _tmp41_, (gint) NOTIFICATIONS_NOTIFICATION_COLUMN_APP_ICON);
#line 115 "../src/Services/Notification.vala"
	_g_free0 (self->app_icon);
#line 115 "../src/Services/Notification.vala"
	self->app_icon = _tmp42_;
#line 116 "../src/Services/Notification.vala"
	_tmp44_ = self->app_icon;
#line 116 "../src/Services/Notification.vala"
	if (g_strcmp0 (_tmp44_, "") == 0) {
#line 767 "Notification.c"
		GDesktopAppInfo* _tmp45_;
#line 116 "../src/Services/Notification.vala"
		_tmp45_ = self->app_info;
#line 116 "../src/Services/Notification.vala"
		_tmp43_ = _tmp45_ != NULL;
#line 773 "Notification.c"
	} else {
#line 116 "../src/Services/Notification.vala"
		_tmp43_ = FALSE;
#line 777 "Notification.c"
	}
#line 116 "../src/Services/Notification.vala"
	if (_tmp43_) {
#line 781 "Notification.c"
		GDesktopAppInfo* _tmp46_;
		GIcon* _tmp47_;
		gchar* _tmp48_;
#line 117 "../src/Services/Notification.vala"
		_tmp46_ = self->app_info;
#line 117 "../src/Services/Notification.vala"
		_tmp47_ = g_app_info_get_icon ((GAppInfo*) _tmp46_);
#line 117 "../src/Services/Notification.vala"
		_tmp48_ = g_icon_to_string (_tmp47_);
#line 117 "../src/Services/Notification.vala"
		_g_free0 (self->app_icon);
#line 117 "../src/Services/Notification.vala"
		self->app_icon = _tmp48_;
#line 795 "Notification.c"
	}
#line 121 "../src/Services/Notification.vala"
	_tmp50_ = hints;
#line 121 "../src/Services/Notification.vala"
	_tmp51_ = notifications_notification_lookup_string (self, _tmp50_, "image-path");
#line 121 "../src/Services/Notification.vala"
	_tmp52_ = _tmp51_;
#line 121 "../src/Services/Notification.vala"
	notifications_notification_set_image_path (self, _tmp52_);
#line 121 "../src/Services/Notification.vala"
	_tmp53_ = g_strcmp0 (_tmp52_, "") != 0;
#line 121 "../src/Services/Notification.vala"
	_g_free0 (_tmp52_);
#line 121 "../src/Services/Notification.vala"
	if (_tmp53_) {
#line 121 "../src/Services/Notification.vala"
		_tmp49_ = TRUE;
#line 813 "Notification.c"
	} else {
		GVariant* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
#line 121 "../src/Services/Notification.vala"
		_tmp54_ = hints;
#line 121 "../src/Services/Notification.vala"
		_tmp55_ = notifications_notification_lookup_string (self, _tmp54_, "image_path");
#line 121 "../src/Services/Notification.vala"
		_tmp56_ = _tmp55_;
#line 121 "../src/Services/Notification.vala"
		notifications_notification_set_image_path (self, _tmp56_);
#line 121 "../src/Services/Notification.vala"
		_tmp49_ = g_strcmp0 (_tmp56_, "") != 0;
#line 121 "../src/Services/Notification.vala"
		_g_free0 (_tmp56_);
#line 830 "Notification.c"
	}
#line 121 "../src/Services/Notification.vala"
	if (_tmp49_) {
#line 834 "Notification.c"
		const gchar* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_;
		gboolean _tmp60_ = FALSE;
		GtkIconTheme* _tmp61_;
		const gchar* _tmp62_;
		gboolean _tmp68_ = FALSE;
		const gchar* _tmp69_;
		gboolean is_a_path = FALSE;
		gboolean _tmp71_ = FALSE;
		GIcon* _tmp72_;
#line 123 "../src/Services/Notification.vala"
		_tmp57_ = self->priv->_image_path;
#line 123 "../src/Services/Notification.vala"
		_tmp58_ = string_replace (_tmp57_, "-symbolic", "");
#line 123 "../src/Services/Notification.vala"
		_tmp59_ = _tmp58_;
#line 123 "../src/Services/Notification.vala"
		notifications_notification_set_image_path (self, _tmp59_);
#line 123 "../src/Services/Notification.vala"
		_g_free0 (_tmp59_);
#line 126 "../src/Services/Notification.vala"
		_tmp61_ = gtk_icon_theme_get_default ();
#line 126 "../src/Services/Notification.vala"
		_tmp62_ = self->priv->_image_path;
#line 126 "../src/Services/Notification.vala"
		if (gtk_icon_theme_has_icon (_tmp61_, _tmp62_)) {
#line 862 "Notification.c"
			const gchar* _tmp63_;
			const gchar* _tmp64_;
#line 126 "../src/Services/Notification.vala"
			_tmp63_ = self->priv->_image_path;
#line 126 "../src/Services/Notification.vala"
			_tmp64_ = self->app_icon;
#line 126 "../src/Services/Notification.vala"
			_tmp60_ = g_strcmp0 (_tmp63_, _tmp64_) != 0;
#line 871 "Notification.c"
		} else {
#line 126 "../src/Services/Notification.vala"
			_tmp60_ = FALSE;
#line 875 "Notification.c"
		}
#line 126 "../src/Services/Notification.vala"
		if (_tmp60_) {
#line 879 "Notification.c"
			const gchar* _tmp65_;
			GThemedIcon* _tmp66_;
			GThemedIcon* _tmp67_;
#line 127 "../src/Services/Notification.vala"
			_tmp65_ = self->priv->_image_path;
#line 127 "../src/Services/Notification.vala"
			_tmp66_ = (GThemedIcon*) g_themed_icon_new (_tmp65_);
#line 127 "../src/Services/Notification.vala"
			_tmp67_ = _tmp66_;
#line 127 "../src/Services/Notification.vala"
			notifications_notification_set_badge_icon (self, (GIcon*) _tmp67_);
#line 127 "../src/Services/Notification.vala"
			_g_object_unref0 (_tmp67_);
#line 893 "Notification.c"
		}
#line 130 "../src/Services/Notification.vala"
		_tmp69_ = self->priv->_image_path;
#line 130 "../src/Services/Notification.vala"
		if (g_str_has_prefix (_tmp69_, "/")) {
#line 130 "../src/Services/Notification.vala"
			_tmp68_ = TRUE;
#line 901 "Notification.c"
		} else {
			const gchar* _tmp70_;
#line 130 "../src/Services/Notification.vala"
			_tmp70_ = self->priv->_image_path;
#line 130 "../src/Services/Notification.vala"
			_tmp68_ = g_str_has_prefix (_tmp70_, "file://");
#line 908 "Notification.c"
		}
#line 130 "../src/Services/Notification.vala"
		is_a_path = _tmp68_;
#line 131 "../src/Services/Notification.vala"
		_tmp72_ = self->priv->_badge_icon;
#line 131 "../src/Services/Notification.vala"
		if (_tmp72_ != NULL) {
#line 131 "../src/Services/Notification.vala"
			_tmp71_ = TRUE;
#line 918 "Notification.c"
		} else {
#line 131 "../src/Services/Notification.vala"
			_tmp71_ = !is_a_path;
#line 922 "Notification.c"
		}
#line 131 "../src/Services/Notification.vala"
		if (_tmp71_) {
#line 132 "../src/Services/Notification.vala"
			notifications_notification_set_image_path (self, "");
#line 928 "Notification.c"
		}
	}
#line 137 "../src/Services/Notification.vala"
	buf = NULL;
#line 138 "../src/Services/Notification.vala"
	_tmp75_ = hints;
#line 138 "../src/Services/Notification.vala"
	_tmp76_ = notifications_notification_lookup_pixbuf (self, _tmp75_, "image-data");
#line 138 "../src/Services/Notification.vala"
	_g_object_unref0 (buf);
#line 138 "../src/Services/Notification.vala"
	buf = _tmp76_;
#line 138 "../src/Services/Notification.vala"
	_tmp77_ = buf;
#line 138 "../src/Services/Notification.vala"
	if (_tmp77_ != NULL) {
#line 138 "../src/Services/Notification.vala"
		_tmp74_ = TRUE;
#line 947 "Notification.c"
	} else {
		GVariant* _tmp78_;
		GdkPixbuf* _tmp79_;
		GdkPixbuf* _tmp80_;
#line 138 "../src/Services/Notification.vala"
		_tmp78_ = hints;
#line 138 "../src/Services/Notification.vala"
		_tmp79_ = notifications_notification_lookup_pixbuf (self, _tmp78_, "image_data");
#line 138 "../src/Services/Notification.vala"
		_g_object_unref0 (buf);
#line 138 "../src/Services/Notification.vala"
		buf = _tmp79_;
#line 138 "../src/Services/Notification.vala"
		_tmp80_ = buf;
#line 138 "../src/Services/Notification.vala"
		_tmp74_ = _tmp80_ != NULL;
#line 964 "Notification.c"
	}
#line 138 "../src/Services/Notification.vala"
	if (_tmp74_) {
#line 138 "../src/Services/Notification.vala"
		_tmp73_ = TRUE;
#line 970 "Notification.c"
	} else {
		GVariant* _tmp81_;
		GdkPixbuf* _tmp82_;
		GdkPixbuf* _tmp83_;
#line 138 "../src/Services/Notification.vala"
		_tmp81_ = hints;
#line 138 "../src/Services/Notification.vala"
		_tmp82_ = notifications_notification_lookup_pixbuf (self, _tmp81_, "icon_data");
#line 138 "../src/Services/Notification.vala"
		_g_object_unref0 (buf);
#line 138 "../src/Services/Notification.vala"
		buf = _tmp82_;
#line 138 "../src/Services/Notification.vala"
		_tmp83_ = buf;
#line 138 "../src/Services/Notification.vala"
		_tmp73_ = _tmp83_ != NULL;
#line 987 "Notification.c"
	}
#line 138 "../src/Services/Notification.vala"
	if (_tmp73_) {
#line 991 "Notification.c"
		gchar* tmpfile = NULL;
		GdkPixbuf* _tmp84_;
		gchar* _tmp85_;
		const gchar* _tmp86_;
#line 139 "../src/Services/Notification.vala"
		_tmp84_ = buf;
#line 139 "../src/Services/Notification.vala"
		_tmp85_ = notifications_notification_store_pixbuf (self, _tmp84_);
#line 139 "../src/Services/Notification.vala"
		tmpfile = _tmp85_;
#line 140 "../src/Services/Notification.vala"
		_tmp86_ = tmpfile;
#line 140 "../src/Services/Notification.vala"
		if (_tmp86_ != NULL) {
#line 1006 "Notification.c"
			const gchar* _tmp87_;
#line 141 "../src/Services/Notification.vala"
			_tmp87_ = tmpfile;
#line 141 "../src/Services/Notification.vala"
			notifications_notification_set_image_path (self, _tmp87_);
#line 142 "../src/Services/Notification.vala"
			self->has_temp_file = TRUE;
#line 1014 "Notification.c"
		}
#line 138 "../src/Services/Notification.vala"
		_g_free0 (tmpfile);
#line 1018 "Notification.c"
	}
#line 146 "../src/Services/Notification.vala"
	_tmp88_ = self->app_info;
#line 146 "../src/Services/Notification.vala"
	if (_tmp88_ == NULL) {
#line 1024 "Notification.c"
		gchar* _tmp89_;
		const gchar* _tmp90_;
		GDesktopAppInfo* _tmp91_;
#line 147 "../src/Services/Notification.vala"
		_tmp89_ = g_strdup (NOTIFICATIONS_NOTIFICATION_FALLBACK_DESKTOP_ID);
#line 147 "../src/Services/Notification.vala"
		_g_free0 (self->desktop_id);
#line 147 "../src/Services/Notification.vala"
		self->desktop_id = _tmp89_;
#line 148 "../src/Services/Notification.vala"
		_tmp90_ = self->desktop_id;
#line 148 "../src/Services/Notification.vala"
		_tmp91_ = g_desktop_app_info_new (_tmp90_);
#line 148 "../src/Services/Notification.vala"
		_g_object_unref0 (self->app_info);
#line 148 "../src/Services/Notification.vala"
		self->app_info = _tmp91_;
#line 1042 "Notification.c"
	}
#line 88 "../src/Services/Notification.vala"
	_g_object_unref0 (buf);
#line 88 "../src/Services/Notification.vala"
	_g_variant_unref0 (hints);
#line 88 "../src/Services/Notification.vala"
	_g_variant_unref0 (body);
#line 88 "../src/Services/Notification.vala"
	return self;
#line 1052 "Notification.c"
}

NotificationsNotification*
notifications_notification_new_from_message (GDBusMessage* message,
                                             guint32 _id)
{
#line 88 "../src/Services/Notification.vala"
	return notifications_notification_construct_from_message (NOTIFICATIONS_TYPE_NOTIFICATION, message, _id);
#line 1061 "Notification.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 1082 "Notification.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 172 "../src/Services/Notification.vala"
	return self ? g_object_ref (self) : NULL;
#line 1090 "Notification.c"
}

static GList*
notifications_notification_validate_actions (NotificationsNotification* self,
                                             gchar** actions,
                                             gint actions_length1)
{
	GList* list = NULL;
	GList* result;
#line 152 "../src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 153 "../src/Services/Notification.vala"
	list = NULL;
#line 1104 "Notification.c"
	{
		gint i = 0;
#line 155 "../src/Services/Notification.vala"
		i = 0;
#line 1109 "Notification.c"
		{
			gboolean _tmp0_ = FALSE;
#line 155 "../src/Services/Notification.vala"
			_tmp0_ = TRUE;
#line 155 "../src/Services/Notification.vala"
			while (TRUE) {
#line 1116 "Notification.c"
				const gchar* _tmp1_;
				gchar* label = NULL;
				const gchar* _tmp9_;
				gchar* _tmp10_;
				const gchar* _tmp11_;
				GtkButton* button = NULL;
				const gchar* _tmp13_;
				guint32 _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_;
				GtkButton* _tmp23_ = NULL;
				GtkButton* _tmp24_;
				GtkButton* _tmp25_;
				GtkButton* _tmp26_;
#line 155 "../src/Services/Notification.vala"
				if (!_tmp0_) {
#line 155 "../src/Services/Notification.vala"
					i += 2;
#line 1141 "Notification.c"
				}
#line 155 "../src/Services/Notification.vala"
				_tmp0_ = FALSE;
#line 155 "../src/Services/Notification.vala"
				if (!(i < actions_length1)) {
#line 155 "../src/Services/Notification.vala"
					break;
#line 1149 "Notification.c"
				}
#line 156 "../src/Services/Notification.vala"
				_tmp1_ = actions[i];
#line 156 "../src/Services/Notification.vala"
				if (g_strcmp0 (_tmp1_, NOTIFICATIONS_NOTIFICATION_DEFAULT_ACTION) == 0) {
#line 1155 "Notification.c"
					guint32 _tmp2_;
					gchar* _tmp3_;
					gchar* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
#line 157 "../src/Services/Notification.vala"
					_tmp2_ = self->priv->_server_id;
#line 157 "../src/Services/Notification.vala"
					_tmp3_ = g_strdup_printf ("%u", _tmp2_);
#line 157 "../src/Services/Notification.vala"
					_tmp4_ = _tmp3_;
#line 157 "../src/Services/Notification.vala"
					_tmp5_ = g_strconcat (_tmp4_, ".", NULL);
#line 157 "../src/Services/Notification.vala"
					_tmp6_ = _tmp5_;
#line 157 "../src/Services/Notification.vala"
					_tmp7_ = g_strconcat (_tmp6_, NOTIFICATIONS_NOTIFICATION_DEFAULT_ACTION, NULL);
#line 157 "../src/Services/Notification.vala"
					_tmp8_ = _tmp7_;
#line 157 "../src/Services/Notification.vala"
					notifications_notification_set_default_action (self, _tmp8_);
#line 157 "../src/Services/Notification.vala"
					_g_free0 (_tmp8_);
#line 157 "../src/Services/Notification.vala"
					_g_free0 (_tmp6_);
#line 157 "../src/Services/Notification.vala"
					_g_free0 (_tmp4_);
#line 158 "../src/Services/Notification.vala"
					continue;
#line 1187 "Notification.c"
				}
#line 161 "../src/Services/Notification.vala"
				_tmp9_ = actions[i + 1];
#line 161 "../src/Services/Notification.vala"
				_tmp10_ = string_strip (_tmp9_);
#line 161 "../src/Services/Notification.vala"
				label = _tmp10_;
#line 162 "../src/Services/Notification.vala"
				_tmp11_ = label;
#line 162 "../src/Services/Notification.vala"
				if (g_strcmp0 (_tmp11_, "") == 0) {
#line 1199 "Notification.c"
					const gchar* _tmp12_;
#line 163 "../src/Services/Notification.vala"
					_tmp12_ = actions[i];
#line 163 "../src/Services/Notification.vala"
					g_warning ("Notification.vala:163: Action '%s' sent without label, skipping…", _tmp12_);
#line 164 "../src/Services/Notification.vala"
					_g_free0 (label);
#line 164 "../src/Services/Notification.vala"
					continue;
#line 1209 "Notification.c"
				}
#line 167 "../src/Services/Notification.vala"
				_tmp13_ = label;
#line 167 "../src/Services/Notification.vala"
				_tmp14_ = self->priv->_server_id;
#line 167 "../src/Services/Notification.vala"
				_tmp15_ = g_strdup_printf ("%u", _tmp14_);
#line 167 "../src/Services/Notification.vala"
				_tmp16_ = _tmp15_;
#line 167 "../src/Services/Notification.vala"
				_tmp17_ = g_strconcat (NOTIFICATIONS_NOTIFICATIONS_LIST_ACTION_PREFIX, _tmp16_, NULL);
#line 167 "../src/Services/Notification.vala"
				_tmp18_ = _tmp17_;
#line 167 "../src/Services/Notification.vala"
				_tmp19_ = g_strconcat (_tmp18_, ".", NULL);
#line 167 "../src/Services/Notification.vala"
				_tmp20_ = _tmp19_;
#line 167 "../src/Services/Notification.vala"
				_tmp21_ = actions[i];
#line 167 "../src/Services/Notification.vala"
				_tmp22_ = g_strconcat (_tmp20_, _tmp21_, NULL);
#line 167 "../src/Services/Notification.vala"
				_tmp23_ = (GtkButton*) gtk_button_new_with_label (_tmp13_);
#line 167 "../src/Services/Notification.vala"
				gtk_actionable_set_action_name ((GtkActionable*) _tmp23_, _tmp22_);
#line 167 "../src/Services/Notification.vala"
				_g_free0 (_tmp22_);
#line 167 "../src/Services/Notification.vala"
				g_object_set ((GtkWidget*) _tmp23_, "width-request", 86, NULL);
#line 167 "../src/Services/Notification.vala"
				g_object_ref_sink (_tmp23_);
#line 167 "../src/Services/Notification.vala"
				_tmp24_ = _tmp23_;
#line 167 "../src/Services/Notification.vala"
				_g_free0 (_tmp20_);
#line 167 "../src/Services/Notification.vala"
				_g_free0 (_tmp18_);
#line 167 "../src/Services/Notification.vala"
				_g_free0 (_tmp16_);
#line 167 "../src/Services/Notification.vala"
				button = _tmp24_;
#line 172 "../src/Services/Notification.vala"
				_tmp25_ = button;
#line 172 "../src/Services/Notification.vala"
				_tmp26_ = _g_object_ref0 (_tmp25_);
#line 172 "../src/Services/Notification.vala"
				list = g_list_append (list, _tmp26_);
#line 155 "../src/Services/Notification.vala"
				_g_object_unref0 (button);
#line 155 "../src/Services/Notification.vala"
				_g_free0 (label);
#line 1261 "Notification.c"
			}
		}
	}
#line 175 "../src/Services/Notification.vala"
	result = list;
#line 175 "../src/Services/Notification.vala"
	return result;
#line 1269 "Notification.c"
}

static gchar*
notifications_notification_get_string (NotificationsNotification* self,
                                       GVariant* tuple,
                                       gint column)
{
	GVariant* child = NULL;
	GVariant* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 178 "../src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 178 "../src/Services/Notification.vala"
	g_return_val_if_fail (tuple != NULL, NULL);
#line 179 "../src/Services/Notification.vala"
	_tmp0_ = g_variant_get_child_value (tuple, (gsize) column);
#line 179 "../src/Services/Notification.vala"
	child = _tmp0_;
#line 180 "../src/Services/Notification.vala"
	_tmp1_ = g_variant_dup_string (child, NULL);
#line 180 "../src/Services/Notification.vala"
	result = _tmp1_;
#line 180 "../src/Services/Notification.vala"
	_g_variant_unref0 (child);
#line 180 "../src/Services/Notification.vala"
	return result;
#line 1297 "Notification.c"
}

static guint32
notifications_notification_get_uint32 (NotificationsNotification* self,
                                       GVariant* tuple,
                                       gint column)
{
	GVariant* child = NULL;
	GVariant* _tmp0_;
	guint32 result;
#line 183 "../src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 183 "../src/Services/Notification.vala"
	g_return_val_if_fail (tuple != NULL, 0U);
#line 184 "../src/Services/Notification.vala"
	_tmp0_ = g_variant_get_child_value (tuple, (gsize) column);
#line 184 "../src/Services/Notification.vala"
	child = _tmp0_;
#line 185 "../src/Services/Notification.vala"
	result = g_variant_get_uint32 (child);
#line 185 "../src/Services/Notification.vala"
	_g_variant_unref0 (child);
#line 185 "../src/Services/Notification.vala"
	return result;
#line 1322 "Notification.c"
}

static gchar*
notifications_notification_lookup_string (NotificationsNotification* self,
                                          GVariant* tuple,
                                          const gchar* key)
{
	GVariant* child = NULL;
	GVariant* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GVariant* _tmp2_;
	GVariant* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 188 "../src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 188 "../src/Services/Notification.vala"
	g_return_val_if_fail (tuple != NULL, NULL);
#line 188 "../src/Services/Notification.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 189 "../src/Services/Notification.vala"
	_tmp0_ = g_variant_lookup_value (tuple, key, NULL);
#line 189 "../src/Services/Notification.vala"
	child = _tmp0_;
#line 191 "../src/Services/Notification.vala"
	_tmp2_ = child;
#line 191 "../src/Services/Notification.vala"
	if (_tmp2_ == NULL) {
#line 191 "../src/Services/Notification.vala"
		_tmp1_ = TRUE;
#line 1353 "Notification.c"
	} else {
		GVariant* _tmp3_;
		const GVariantType* _tmp4_;
#line 191 "../src/Services/Notification.vala"
		_tmp3_ = child;
#line 191 "../src/Services/Notification.vala"
		_tmp4_ = G_VARIANT_TYPE_STRING;
#line 191 "../src/Services/Notification.vala"
		_tmp1_ = !g_variant_is_of_type (_tmp3_, _tmp4_);
#line 1363 "Notification.c"
	}
#line 191 "../src/Services/Notification.vala"
	if (_tmp1_) {
#line 1367 "Notification.c"
		gchar* _tmp5_;
#line 192 "../src/Services/Notification.vala"
		_tmp5_ = g_strdup ("");
#line 192 "../src/Services/Notification.vala"
		result = _tmp5_;
#line 192 "../src/Services/Notification.vala"
		_g_variant_unref0 (child);
#line 192 "../src/Services/Notification.vala"
		return result;
#line 1377 "Notification.c"
	}
#line 195 "../src/Services/Notification.vala"
	_tmp6_ = child;
#line 195 "../src/Services/Notification.vala"
	_tmp7_ = g_variant_dup_string (_tmp6_, NULL);
#line 195 "../src/Services/Notification.vala"
	result = _tmp7_;
#line 195 "../src/Services/Notification.vala"
	_g_variant_unref0 (child);
#line 195 "../src/Services/Notification.vala"
	return result;
#line 1389 "Notification.c"
}

static GdkPixbuf*
notifications_notification_lookup_pixbuf (NotificationsNotification* self,
                                          GVariant* tuple,
                                          const gchar* key)
{
	GVariant* img = NULL;
	GVariant* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GVariant* _tmp2_;
	gint width = 0;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	gint _tmp8_;
	gint height = 0;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	gint _tmp12_;
	gint rowstride = 0;
	GVariant* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	gint _tmp16_;
	gboolean has_alpha = FALSE;
	GVariant* _tmp17_;
	GVariant* _tmp18_;
	GVariant* _tmp19_;
	gboolean _tmp20_;
	gint bits_per_sample = 0;
	GVariant* _tmp21_;
	GVariant* _tmp22_;
	GVariant* _tmp23_;
	gint _tmp24_;
	guint8* raw = NULL;
	GVariant* _tmp25_;
	GVariant* _tmp26_;
	GVariant* _tmp27_;
	void* _tmp28_;
	guint8* _tmp29_;
	gint _tmp29__length1;
	gint raw_length1;
	gint _raw_size_;
	GdkPixbuf* pixbuf = NULL;
	guint8* _tmp30_;
	gint _tmp30__length1;
	GdkPixbuf* _tmp31_;
	GdkPixbuf* _tmp32_;
	GdkPixbuf* _tmp33_;
	GdkPixbuf* result;
#line 198 "../src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 198 "../src/Services/Notification.vala"
	g_return_val_if_fail (tuple != NULL, NULL);
#line 198 "../src/Services/Notification.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 199 "../src/Services/Notification.vala"
	_tmp0_ = g_variant_lookup_value (tuple, key, NULL);
#line 199 "../src/Services/Notification.vala"
	img = _tmp0_;
#line 201 "../src/Services/Notification.vala"
	_tmp2_ = img;
#line 201 "../src/Services/Notification.vala"
	if (_tmp2_ == NULL) {
#line 201 "../src/Services/Notification.vala"
		_tmp1_ = TRUE;
#line 1458 "Notification.c"
	} else {
		GVariant* _tmp3_;
		const gchar* _tmp4_;
#line 201 "../src/Services/Notification.vala"
		_tmp3_ = img;
#line 201 "../src/Services/Notification.vala"
		_tmp4_ = g_variant_get_type_string (_tmp3_);
#line 201 "../src/Services/Notification.vala"
		_tmp1_ = g_strcmp0 (_tmp4_, "(iiibiiay)") != 0;
#line 1468 "Notification.c"
	}
#line 201 "../src/Services/Notification.vala"
	if (_tmp1_) {
#line 202 "../src/Services/Notification.vala"
		result = NULL;
#line 202 "../src/Services/Notification.vala"
		_g_variant_unref0 (img);
#line 202 "../src/Services/Notification.vala"
		return result;
#line 1478 "Notification.c"
	}
#line 205 "../src/Services/Notification.vala"
	_tmp5_ = img;
#line 205 "../src/Services/Notification.vala"
	_tmp6_ = g_variant_get_child_value (_tmp5_, (gsize) 0);
#line 205 "../src/Services/Notification.vala"
	_tmp7_ = _tmp6_;
#line 205 "../src/Services/Notification.vala"
	_tmp8_ = (gint) g_variant_get_int32 (_tmp7_);
#line 205 "../src/Services/Notification.vala"
	_g_variant_unref0 (_tmp7_);
#line 205 "../src/Services/Notification.vala"
	width = _tmp8_;
#line 206 "../src/Services/Notification.vala"
	_tmp9_ = img;
#line 206 "../src/Services/Notification.vala"
	_tmp10_ = g_variant_get_child_value (_tmp9_, (gsize) 1);
#line 206 "../src/Services/Notification.vala"
	_tmp11_ = _tmp10_;
#line 206 "../src/Services/Notification.vala"
	_tmp12_ = (gint) g_variant_get_int32 (_tmp11_);
#line 206 "../src/Services/Notification.vala"
	_g_variant_unref0 (_tmp11_);
#line 206 "../src/Services/Notification.vala"
	height = _tmp12_;
#line 207 "../src/Services/Notification.vala"
	_tmp13_ = img;
#line 207 "../src/Services/Notification.vala"
	_tmp14_ = g_variant_get_child_value (_tmp13_, (gsize) 2);
#line 207 "../src/Services/Notification.vala"
	_tmp15_ = _tmp14_;
#line 207 "../src/Services/Notification.vala"
	_tmp16_ = (gint) g_variant_get_int32 (_tmp15_);
#line 207 "../src/Services/Notification.vala"
	_g_variant_unref0 (_tmp15_);
#line 207 "../src/Services/Notification.vala"
	rowstride = _tmp16_;
#line 208 "../src/Services/Notification.vala"
	_tmp17_ = img;
#line 208 "../src/Services/Notification.vala"
	_tmp18_ = g_variant_get_child_value (_tmp17_, (gsize) 3);
#line 208 "../src/Services/Notification.vala"
	_tmp19_ = _tmp18_;
#line 208 "../src/Services/Notification.vala"
	_tmp20_ = g_variant_get_boolean (_tmp19_);
#line 208 "../src/Services/Notification.vala"
	_g_variant_unref0 (_tmp19_);
#line 208 "../src/Services/Notification.vala"
	has_alpha = _tmp20_;
#line 209 "../src/Services/Notification.vala"
	_tmp21_ = img;
#line 209 "../src/Services/Notification.vala"
	_tmp22_ = g_variant_get_child_value (_tmp21_, (gsize) 4);
#line 209 "../src/Services/Notification.vala"
	_tmp23_ = _tmp22_;
#line 209 "../src/Services/Notification.vala"
	_tmp24_ = (gint) g_variant_get_int32 (_tmp23_);
#line 209 "../src/Services/Notification.vala"
	_g_variant_unref0 (_tmp23_);
#line 209 "../src/Services/Notification.vala"
	bits_per_sample = _tmp24_;
#line 210 "../src/Services/Notification.vala"
	_tmp25_ = img;
#line 210 "../src/Services/Notification.vala"
	_tmp26_ = g_variant_get_child_value (_tmp25_, (gsize) 6);
#line 210 "../src/Services/Notification.vala"
	_tmp27_ = _tmp26_;
#line 210 "../src/Services/Notification.vala"
	_tmp28_ = g_variant_get_data (_tmp27_);
#line 210 "../src/Services/Notification.vala"
	_tmp29_ = (guint8*) _tmp28_;
#line 210 "../src/Services/Notification.vala"
	_tmp29__length1 = -1;
#line 210 "../src/Services/Notification.vala"
	_g_variant_unref0 (_tmp27_);
#line 210 "../src/Services/Notification.vala"
	raw = _tmp29_;
#line 210 "../src/Services/Notification.vala"
	raw_length1 = _tmp29__length1;
#line 210 "../src/Services/Notification.vala"
	_raw_size_ = raw_length1;
#line 213 "../src/Services/Notification.vala"
	_tmp30_ = raw;
#line 213 "../src/Services/Notification.vala"
	_tmp30__length1 = raw_length1;
#line 213 "../src/Services/Notification.vala"
	_tmp31_ = gdk_pixbuf_new_from_data (_tmp30_, GDK_COLORSPACE_RGB, has_alpha, bits_per_sample, width, height, rowstride, (GdkPixbufDestroyNotify) NULL, NULL);
#line 213 "../src/Services/Notification.vala"
	pixbuf = _tmp31_;
#line 215 "../src/Services/Notification.vala"
	_tmp32_ = pixbuf;
#line 215 "../src/Services/Notification.vala"
	_tmp33_ = gdk_pixbuf_copy (_tmp32_);
#line 215 "../src/Services/Notification.vala"
	result = _tmp33_;
#line 215 "../src/Services/Notification.vala"
	_g_object_unref0 (pixbuf);
#line 215 "../src/Services/Notification.vala"
	_g_variant_unref0 (img);
#line 215 "../src/Services/Notification.vala"
	return result;
#line 1580 "Notification.c"
}

static gchar*
notifications_notification_make_temp_file (NotificationsNotification* self,
                                           const gchar* tmpl)
{
	GFileIOStream* iostream = NULL;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 218 "../src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 218 "../src/Services/Notification.vala"
	g_return_val_if_fail (tmpl != NULL, NULL);
#line 1594 "Notification.c"
	{
		GFile* file = NULL;
		GFileIOStream* _tmp0_ = NULL;
		GFile* _tmp1_;
		gchar* _tmp2_;
#line 221 "../src/Services/Notification.vala"
		_tmp1_ = g_file_new_tmp (tmpl, &_tmp0_, &_inner_error0_);
#line 221 "../src/Services/Notification.vala"
		_g_object_unref0 (iostream);
#line 221 "../src/Services/Notification.vala"
		iostream = _tmp0_;
#line 221 "../src/Services/Notification.vala"
		file = _tmp1_;
#line 221 "../src/Services/Notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1610 "Notification.c"
			goto __catch0_g_error;
		}
#line 222 "../src/Services/Notification.vala"
		_tmp2_ = g_file_get_path (file);
#line 222 "../src/Services/Notification.vala"
		result = _tmp2_;
#line 222 "../src/Services/Notification.vala"
		_g_object_unref0 (file);
#line 222 "../src/Services/Notification.vala"
		_g_object_unref0 (iostream);
#line 222 "../src/Services/Notification.vala"
		return result;
#line 1623 "Notification.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 220 "../src/Services/Notification.vala"
		g_clear_error (&_inner_error0_);
#line 224 "../src/Services/Notification.vala"
		result = NULL;
#line 224 "../src/Services/Notification.vala"
		_g_object_unref0 (iostream);
#line 224 "../src/Services/Notification.vala"
		return result;
#line 1636 "Notification.c"
	}
	__finally0:
#line 220 "../src/Services/Notification.vala"
	_g_object_unref0 (iostream);
#line 220 "../src/Services/Notification.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 220 "../src/Services/Notification.vala"
	g_clear_error (&_inner_error0_);
#line 220 "../src/Services/Notification.vala"
	return NULL;
#line 1647 "Notification.c"
}

gchar*
notifications_notification_store_pixbuf (NotificationsNotification* self,
                                         GdkPixbuf* pixbuf)
{
	gchar* tmpfile = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 228 "../src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 228 "../src/Services/Notification.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 229 "../src/Services/Notification.vala"
	_tmp0_ = notifications_notification_make_temp_file (self, "wingpanel-XXXXXX.png");
#line 229 "../src/Services/Notification.vala"
	tmpfile = _tmp0_;
#line 230 "../src/Services/Notification.vala"
	_tmp1_ = tmpfile;
#line 230 "../src/Services/Notification.vala"
	if (_tmp1_ != NULL) {
#line 1671 "Notification.c"
		{
			gboolean _tmp2_ = FALSE;
			const gchar* _tmp3_;
#line 232 "../src/Services/Notification.vala"
			_tmp3_ = tmpfile;
#line 232 "../src/Services/Notification.vala"
			_tmp2_ = gdk_pixbuf_save (pixbuf, _tmp3_, "png", &_inner_error0_, NULL, NULL);
#line 232 "../src/Services/Notification.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1681 "Notification.c"
				goto __catch0_g_error;
			}
#line 232 "../src/Services/Notification.vala"
			if (_tmp2_) {
#line 233 "../src/Services/Notification.vala"
				result = tmpfile;
#line 233 "../src/Services/Notification.vala"
				return result;
#line 1690 "Notification.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp4_;
			const gchar* _tmp5_;
			GFile* file = NULL;
			const gchar* _tmp6_;
			GFile* _tmp7_;
#line 231 "../src/Services/Notification.vala"
			e = _inner_error0_;
#line 231 "../src/Services/Notification.vala"
			_inner_error0_ = NULL;
#line 236 "../src/Services/Notification.vala"
			_tmp4_ = e;
#line 236 "../src/Services/Notification.vala"
			_tmp5_ = _tmp4_->message;
#line 236 "../src/Services/Notification.vala"
			g_critical ("Notification.vala:236: Unable to cache image: %s", _tmp5_);
#line 237 "../src/Services/Notification.vala"
			_tmp6_ = tmpfile;
#line 237 "../src/Services/Notification.vala"
			_tmp7_ = g_file_new_for_path (_tmp6_);
#line 237 "../src/Services/Notification.vala"
			file = _tmp7_;
#line 1718 "Notification.c"
			{
				GFile* _tmp8_;
#line 239 "../src/Services/Notification.vala"
				_tmp8_ = file;
#line 239 "../src/Services/Notification.vala"
				g_file_delete (_tmp8_, NULL, &_inner_error0_);
#line 239 "../src/Services/Notification.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1727 "Notification.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				const gchar* _tmp9_;
#line 238 "../src/Services/Notification.vala"
				g_clear_error (&_inner_error0_);
#line 241 "../src/Services/Notification.vala"
				_tmp9_ = tmpfile;
#line 241 "../src/Services/Notification.vala"
				g_critical ("Notification.vala:241: Unable to delete tmpfile: %s", _tmp9_);
#line 1741 "Notification.c"
			}
			__finally1:
#line 238 "../src/Services/Notification.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 238 "../src/Services/Notification.vala"
				_g_object_unref0 (file);
#line 238 "../src/Services/Notification.vala"
				_g_error_free0 (e);
#line 238 "../src/Services/Notification.vala"
				_g_free0 (tmpfile);
#line 238 "../src/Services/Notification.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 238 "../src/Services/Notification.vala"
				g_clear_error (&_inner_error0_);
#line 238 "../src/Services/Notification.vala"
				return NULL;
#line 1758 "Notification.c"
			}
#line 231 "../src/Services/Notification.vala"
			_g_object_unref0 (file);
#line 231 "../src/Services/Notification.vala"
			_g_error_free0 (e);
#line 1764 "Notification.c"
		}
		__finally0:
#line 231 "../src/Services/Notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 231 "../src/Services/Notification.vala"
			_g_free0 (tmpfile);
#line 231 "../src/Services/Notification.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 231 "../src/Services/Notification.vala"
			g_clear_error (&_inner_error0_);
#line 231 "../src/Services/Notification.vala"
			return NULL;
#line 1777 "Notification.c"
		}
	}
#line 245 "../src/Services/Notification.vala"
	result = NULL;
#line 245 "../src/Services/Notification.vala"
	_g_free0 (tmpfile);
#line 245 "../src/Services/Notification.vala"
	return result;
#line 1786 "Notification.c"
}

const gchar*
notifications_notification_get_internal_id (NotificationsNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 29 "../src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/Services/Notification.vala"
	_tmp0_ = self->priv->_internal_id;
#line 29 "../src/Services/Notification.vala"
	result = _tmp0_;
#line 29 "../src/Services/Notification.vala"
	return result;
#line 1802 "Notification.c"
}

void
notifications_notification_set_internal_id (NotificationsNotification* self,
                                            const gchar* value)
{
	gchar* old_value;
#line 29 "../src/Services/Notification.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Services/Notification.vala"
	old_value = notifications_notification_get_internal_id (self);
#line 29 "../src/Services/Notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1816 "Notification.c"
		gchar* _tmp0_;
#line 29 "../src/Services/Notification.vala"
		_tmp0_ = g_strdup (value);
#line 29 "../src/Services/Notification.vala"
		_g_free0 (self->priv->_internal_id);
#line 29 "../src/Services/Notification.vala"
		self->priv->_internal_id = _tmp0_;
#line 29 "../src/Services/Notification.vala"
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_INTERNAL_ID_PROPERTY]);
#line 1826 "Notification.c"
	}
}

const gchar*
notifications_notification_get_image_path (NotificationsNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/Services/Notification.vala"
	_tmp0_ = self->priv->_image_path;
#line 33 "../src/Services/Notification.vala"
	result = _tmp0_;
#line 33 "../src/Services/Notification.vala"
	return result;
#line 1843 "Notification.c"
}

static void
notifications_notification_set_image_path (NotificationsNotification* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 33 "../src/Services/Notification.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Services/Notification.vala"
	old_value = notifications_notification_get_image_path (self);
#line 33 "../src/Services/Notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1857 "Notification.c"
		gchar* _tmp0_;
#line 33 "../src/Services/Notification.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/Services/Notification.vala"
		_g_free0 (self->priv->_image_path);
#line 33 "../src/Services/Notification.vala"
		self->priv->_image_path = _tmp0_;
#line 33 "../src/Services/Notification.vala"
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_IMAGE_PATH_PROPERTY]);
#line 1867 "Notification.c"
	}
}

const gchar*
notifications_notification_get_default_action (NotificationsNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 38 "../src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Services/Notification.vala"
	_tmp0_ = self->priv->_default_action;
#line 38 "../src/Services/Notification.vala"
	result = _tmp0_;
#line 38 "../src/Services/Notification.vala"
	return result;
#line 1884 "Notification.c"
}

static void
notifications_notification_set_default_action (NotificationsNotification* self,
                                               const gchar* value)
{
	gchar* old_value;
#line 38 "../src/Services/Notification.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Services/Notification.vala"
	old_value = notifications_notification_get_default_action (self);
#line 38 "../src/Services/Notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1898 "Notification.c"
		gchar* _tmp0_;
#line 38 "../src/Services/Notification.vala"
		_tmp0_ = g_strdup (value);
#line 38 "../src/Services/Notification.vala"
		_g_free0 (self->priv->_default_action);
#line 38 "../src/Services/Notification.vala"
		self->priv->_default_action = _tmp0_;
#line 38 "../src/Services/Notification.vala"
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_DEFAULT_ACTION_PROPERTY]);
#line 1908 "Notification.c"
	}
}

guint32
notifications_notification_get_server_id (NotificationsNotification* self)
{
	guint32 result;
#line 40 "../src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 40 "../src/Services/Notification.vala"
	result = self->priv->_server_id;
#line 40 "../src/Services/Notification.vala"
	return result;
#line 1922 "Notification.c"
}

void
notifications_notification_set_server_id (NotificationsNotification* self,
                                          guint32 value)
{
	guint32 old_value;
#line 40 "../src/Services/Notification.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/Services/Notification.vala"
	old_value = notifications_notification_get_server_id (self);
#line 40 "../src/Services/Notification.vala"
	if (old_value != value) {
#line 40 "../src/Services/Notification.vala"
		self->priv->_server_id = value;
#line 40 "../src/Services/Notification.vala"
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_SERVER_ID_PROPERTY]);
#line 1940 "Notification.c"
	}
}

GIcon*
notifications_notification_get_badge_icon (NotificationsNotification* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 43 "../src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/Services/Notification.vala"
	_tmp0_ = self->priv->_badge_icon;
#line 43 "../src/Services/Notification.vala"
	result = _tmp0_;
#line 43 "../src/Services/Notification.vala"
	return result;
#line 1957 "Notification.c"
}

void
notifications_notification_set_badge_icon (NotificationsNotification* self,
                                           GIcon* value)
{
	GIcon* old_value;
#line 43 "../src/Services/Notification.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/Services/Notification.vala"
	old_value = notifications_notification_get_badge_icon (self);
#line 43 "../src/Services/Notification.vala"
	if (old_value != value) {
#line 1971 "Notification.c"
		GIcon* _tmp0_;
#line 43 "../src/Services/Notification.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 43 "../src/Services/Notification.vala"
		_g_object_unref0 (self->priv->_badge_icon);
#line 43 "../src/Services/Notification.vala"
		self->priv->_badge_icon = _tmp0_;
#line 43 "../src/Services/Notification.vala"
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_BADGE_ICON_PROPERTY]);
#line 1981 "Notification.c"
	}
}

static void
notifications_notification_class_init (NotificationsNotificationClass * klass,
                                       gpointer klass_data)
{
#line 18 "../src/Services/Notification.vala"
	notifications_notification_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/Services/Notification.vala"
	g_type_class_adjust_private_offset (klass, &NotificationsNotification_private_offset);
#line 18 "../src/Services/Notification.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_notifications_notification_get_property;
#line 18 "../src/Services/Notification.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_notifications_notification_set_property;
#line 18 "../src/Services/Notification.vala"
	G_OBJECT_CLASS (klass)->finalize = notifications_notification_finalize;
#line 18 "../src/Services/Notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_INTERNAL_ID_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_INTERNAL_ID_PROPERTY] = g_param_spec_string ("internal-id", "internal-id", "internal-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 18 "../src/Services/Notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_IMAGE_PATH_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_IMAGE_PATH_PROPERTY] = g_param_spec_string ("image-path", "image-path", "image-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Services/Notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_DEFAULT_ACTION_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_DEFAULT_ACTION_PROPERTY] = g_param_spec_string ("default-action", "default-action", "default-action", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Services/Notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_SERVER_ID_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_SERVER_ID_PROPERTY] = g_param_spec_uint ("server-id", "server-id", "server-id", 0, G_MAXUINT, (guint32) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 18 "../src/Services/Notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_BADGE_ICON_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_BADGE_ICON_PROPERTY] = g_param_spec_object ("badge-icon", "badge-icon", "badge-icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 2009 "Notification.c"
}

static void
notifications_notification_instance_init (NotificationsNotification * self,
                                          gpointer klass)
{
	gchar* _tmp0_;
#line 18 "../src/Services/Notification.vala"
	self->priv = notifications_notification_get_instance_private (self);
#line 33 "../src/Services/Notification.vala"
	_tmp0_ = g_strdup ("");
#line 33 "../src/Services/Notification.vala"
	self->priv->_image_path = _tmp0_;
#line 38 "../src/Services/Notification.vala"
	self->priv->_default_action = NULL;
#line 40 "../src/Services/Notification.vala"
	self->priv->_server_id = (guint32) 0;
#line 46 "../src/Services/Notification.vala"
	self->app_info = NULL;
#line 2029 "Notification.c"
}

static void
notifications_notification_finalize (GObject * obj)
{
	NotificationsNotification * self;
#line 18 "../src/Services/Notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotification);
#line 29 "../src/Services/Notification.vala"
	_g_free0 (self->priv->_internal_id);
#line 30 "../src/Services/Notification.vala"
	_g_free0 (self->app_name);
#line 31 "../src/Services/Notification.vala"
	_g_free0 (self->summary);
#line 32 "../src/Services/Notification.vala"
	_g_free0 (self->message_body);
#line 33 "../src/Services/Notification.vala"
	_g_free0 (self->priv->_image_path);
#line 34 "../src/Services/Notification.vala"
	_g_free0 (self->app_icon);
#line 35 "../src/Services/Notification.vala"
	_g_free0 (self->sender);
#line 36 "../src/Services/Notification.vala"
	self->actions = (_vala_array_free (self->actions, self->actions_length1, (GDestroyNotify) g_free), NULL);
#line 37 "../src/Services/Notification.vala"
	(self->buttons == NULL) ? NULL : (self->buttons = (_g_list_free__g_object_unref0_ (self->buttons), NULL));
#line 38 "../src/Services/Notification.vala"
	_g_free0 (self->priv->_default_action);
#line 42 "../src/Services/Notification.vala"
	_g_date_time_unref0 (self->timestamp);
#line 43 "../src/Services/Notification.vala"
	_g_object_unref0 (self->priv->_badge_icon);
#line 45 "../src/Services/Notification.vala"
	_g_free0 (self->desktop_id);
#line 46 "../src/Services/Notification.vala"
	_g_object_unref0 (self->app_info);
#line 18 "../src/Services/Notification.vala"
	G_OBJECT_CLASS (notifications_notification_parent_class)->finalize (obj);
#line 2068 "Notification.c"
}

static GType
notifications_notification_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NotificationsNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notifications_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotificationsNotification), 0, (GInstanceInitFunc) notifications_notification_instance_init, NULL };
	GType notifications_notification_type_id;
	notifications_notification_type_id = g_type_register_static (G_TYPE_OBJECT, "NotificationsNotification", &g_define_type_info, 0);
	NotificationsNotification_private_offset = g_type_add_instance_private (notifications_notification_type_id, sizeof (NotificationsNotificationPrivate));
	return notifications_notification_type_id;
}

GType
notifications_notification_get_type (void)
{
	static volatile gsize notifications_notification_type_id__once = 0;
	if (g_once_init_enter (&notifications_notification_type_id__once)) {
		GType notifications_notification_type_id;
		notifications_notification_type_id = notifications_notification_get_type_once ();
		g_once_init_leave (&notifications_notification_type_id__once, notifications_notification_type_id);
	}
	return notifications_notification_type_id__once;
}

static void
_vala_notifications_notification_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	NotificationsNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotification);
#line 18 "../src/Services/Notification.vala"
	switch (property_id) {
#line 18 "../src/Services/Notification.vala"
		case NOTIFICATIONS_NOTIFICATION_INTERNAL_ID_PROPERTY:
#line 18 "../src/Services/Notification.vala"
		g_value_set_string (value, notifications_notification_get_internal_id (self));
#line 18 "../src/Services/Notification.vala"
		break;
#line 18 "../src/Services/Notification.vala"
		case NOTIFICATIONS_NOTIFICATION_IMAGE_PATH_PROPERTY:
#line 18 "../src/Services/Notification.vala"
		g_value_set_string (value, notifications_notification_get_image_path (self));
#line 18 "../src/Services/Notification.vala"
		break;
#line 18 "../src/Services/Notification.vala"
		case NOTIFICATIONS_NOTIFICATION_DEFAULT_ACTION_PROPERTY:
#line 18 "../src/Services/Notification.vala"
		g_value_set_string (value, notifications_notification_get_default_action (self));
#line 18 "../src/Services/Notification.vala"
		break;
#line 18 "../src/Services/Notification.vala"
		case NOTIFICATIONS_NOTIFICATION_SERVER_ID_PROPERTY:
#line 18 "../src/Services/Notification.vala"
		g_value_set_uint (value, notifications_notification_get_server_id (self));
#line 18 "../src/Services/Notification.vala"
		break;
#line 18 "../src/Services/Notification.vala"
		case NOTIFICATIONS_NOTIFICATION_BADGE_ICON_PROPERTY:
#line 18 "../src/Services/Notification.vala"
		g_value_set_object (value, notifications_notification_get_badge_icon (self));
#line 18 "../src/Services/Notification.vala"
		break;
#line 2133 "Notification.c"
		default:
#line 18 "../src/Services/Notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Services/Notification.vala"
		break;
#line 2139 "Notification.c"
	}
}

static void
_vala_notifications_notification_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	NotificationsNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotification);
#line 18 "../src/Services/Notification.vala"
	switch (property_id) {
#line 18 "../src/Services/Notification.vala"
		case NOTIFICATIONS_NOTIFICATION_INTERNAL_ID_PROPERTY:
#line 18 "../src/Services/Notification.vala"
		notifications_notification_set_internal_id (self, g_value_get_string (value));
#line 18 "../src/Services/Notification.vala"
		break;
#line 18 "../src/Services/Notification.vala"
		case NOTIFICATIONS_NOTIFICATION_IMAGE_PATH_PROPERTY:
#line 18 "../src/Services/Notification.vala"
		notifications_notification_set_image_path (self, g_value_get_string (value));
#line 18 "../src/Services/Notification.vala"
		break;
#line 18 "../src/Services/Notification.vala"
		case NOTIFICATIONS_NOTIFICATION_DEFAULT_ACTION_PROPERTY:
#line 18 "../src/Services/Notification.vala"
		notifications_notification_set_default_action (self, g_value_get_string (value));
#line 18 "../src/Services/Notification.vala"
		break;
#line 18 "../src/Services/Notification.vala"
		case NOTIFICATIONS_NOTIFICATION_SERVER_ID_PROPERTY:
#line 18 "../src/Services/Notification.vala"
		notifications_notification_set_server_id (self, g_value_get_uint (value));
#line 18 "../src/Services/Notification.vala"
		break;
#line 18 "../src/Services/Notification.vala"
		case NOTIFICATIONS_NOTIFICATION_BADGE_ICON_PROPERTY:
#line 18 "../src/Services/Notification.vala"
		notifications_notification_set_badge_icon (self, g_value_get_object (value));
#line 18 "../src/Services/Notification.vala"
		break;
#line 2183 "Notification.c"
		default:
#line 18 "../src/Services/Notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Services/Notification.vala"
		break;
#line 2189 "Notification.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

