/* Session.c generated by valac 0.56.17, the Vala compiler
 * generated from Session.vala, do not modify */

/*-
 * Copyright 2015-2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* This class is meant to remember the
 * notifications from the current session
 * and restore them in the next session.
 *
 */

#include "notifications.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <glib/gstdio.h>

#define NOTIFICATIONS_SESSION_SESSION_FILE_NAME ".notifications.session"
#define NOTIFICATIONS_SESSION_ACTIONS_KEY "Actions"
#define NOTIFICATIONS_SESSION_APP_ICON_KEY "AppIcon"
#define NOTIFICATIONS_SESSION_APP_NAME_KEY "AppName"
#define NOTIFICATIONS_SESSION_BODY_KEY "Body"
#define NOTIFICATIONS_SESSION_IMAGE_KEY "Image"
#define NOTIFICATIONS_SESSION_DESKTOP_ID_KEY "DesktopID"
#define NOTIFICATIONS_SESSION_REPLACES_ID_KEY "ReplacesID"
#define NOTIFICATIONS_SESSION_SENDER_KEY "Sender"
#define NOTIFICATIONS_SESSION_SUMMARY_KEY "Summary"
#define NOTIFICATIONS_SESSION_UNIX_TIME_KEY "UnixTime"
#define NOTIFICATIONS_SESSION_HAS_TEMP_FILE_KEY "HasTempFile"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	NOTIFICATIONS_SESSION_0_PROPERTY,
	NOTIFICATIONS_SESSION_NUM_PROPERTIES
};
static GParamSpec* notifications_session_properties[NOTIFICATIONS_SESSION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NotificationsSessionPrivate {
	GFile* session_file;
	GKeyFile* key;
	guint write_timeout_id;
};

static gint NotificationsSession_private_offset;
static gpointer notifications_session_parent_class = NULL;
static NotificationsSession* notifications_session_instance;
static NotificationsSession* notifications_session_instance = NULL;

static NotificationsSession* notifications_session_new (void);
static NotificationsSession* notifications_session_construct (GType object_type);
static void notifications_session_create_session_file (NotificationsSession* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void notifications_session_write_contents (NotificationsSession* self);
static gboolean __lambda11_ (NotificationsSession* self);
static gboolean ___lambda11__gsource_func (gpointer self);
static void notifications_session_finalize (GObject * obj);
static GType notifications_session_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
notifications_session_get_instance_private (NotificationsSession* self)
{
	return G_STRUCT_MEMBER_P (self, NotificationsSession_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 49 "../src/Services/Session.vala"
	return self ? g_object_ref (self) : NULL;
#line 105 "Session.c"
}

NotificationsSession*
notifications_session_get_instance (void)
{
	NotificationsSession* _tmp0_;
	NotificationsSession* _tmp2_;
	NotificationsSession* _tmp3_;
	NotificationsSession* result;
#line 45 "../src/Services/Session.vala"
	_tmp0_ = notifications_session_instance;
#line 45 "../src/Services/Session.vala"
	if (_tmp0_ == NULL) {
#line 119 "Session.c"
		NotificationsSession* _tmp1_;
#line 46 "../src/Services/Session.vala"
		_tmp1_ = notifications_session_new ();
#line 46 "../src/Services/Session.vala"
		_g_object_unref0 (notifications_session_instance);
#line 46 "../src/Services/Session.vala"
		notifications_session_instance = _tmp1_;
#line 127 "Session.c"
	}
#line 49 "../src/Services/Session.vala"
	_tmp2_ = notifications_session_instance;
#line 49 "../src/Services/Session.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 49 "../src/Services/Session.vala"
	result = _tmp3_;
#line 49 "../src/Services/Session.vala"
	return result;
#line 137 "Session.c"
}

static NotificationsSession*
notifications_session_construct (GType object_type)
{
	NotificationsSession * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GKeyFile* _tmp5_;
	GKeyFile* _tmp6_;
#line 52 "../src/Services/Session.vala"
	self = (NotificationsSession*) g_object_new (object_type, NULL);
#line 53 "../src/Services/Session.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 53 "../src/Services/Session.vala"
	_tmp1_ = g_build_filename (_tmp0_, NOTIFICATIONS_SESSION_SESSION_FILE_NAME, NULL);
#line 53 "../src/Services/Session.vala"
	_tmp2_ = _tmp1_;
#line 53 "../src/Services/Session.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 53 "../src/Services/Session.vala"
	_g_object_unref0 (self->priv->session_file);
#line 53 "../src/Services/Session.vala"
	self->priv->session_file = _tmp3_;
#line 53 "../src/Services/Session.vala"
	_g_free0 (_tmp2_);
#line 54 "../src/Services/Session.vala"
	_tmp4_ = self->priv->session_file;
#line 54 "../src/Services/Session.vala"
	if (!g_file_query_exists (_tmp4_, NULL)) {
#line 55 "../src/Services/Session.vala"
		notifications_session_create_session_file (self);
#line 173 "Session.c"
	}
#line 58 "../src/Services/Session.vala"
	_tmp5_ = g_key_file_new ();
#line 58 "../src/Services/Session.vala"
	_g_key_file_unref0 (self->priv->key);
#line 58 "../src/Services/Session.vala"
	self->priv->key = _tmp5_;
#line 59 "../src/Services/Session.vala"
	_tmp6_ = self->priv->key;
#line 59 "../src/Services/Session.vala"
	g_key_file_set_list_separator (_tmp6_, ';');
#line 52 "../src/Services/Session.vala"
	return self;
#line 187 "Session.c"
}

static NotificationsSession*
notifications_session_new (void)
{
#line 52 "../src/Services/Session.vala"
	return notifications_session_construct (NOTIFICATIONS_TYPE_SESSION);
#line 195 "Session.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 65 "../src/Services/Session.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 203 "Session.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 65 "../src/Services/Session.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 211 "Session.c"
}

GList*
notifications_session_get_session_notifications (NotificationsSession* self)
{
	GList* list = NULL;
	GError* _inner_error0_ = NULL;
	GList* result;
#line 62 "../src/Services/Session.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 63 "../src/Services/Session.vala"
	list = NULL;
#line 224 "Session.c"
	{
		GKeyFile* _tmp0_;
		GFile* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GKeyFile* _tmp4_;
		gsize _tmp5_ = 0;
		gchar** _tmp6_;
#line 65 "../src/Services/Session.vala"
		_tmp0_ = self->priv->key;
#line 65 "../src/Services/Session.vala"
		_tmp1_ = self->priv->session_file;
#line 65 "../src/Services/Session.vala"
		_tmp2_ = g_file_get_path (_tmp1_);
#line 65 "../src/Services/Session.vala"
		_tmp3_ = _tmp2_;
#line 65 "../src/Services/Session.vala"
		g_key_file_load_from_file (_tmp0_, _tmp3_, G_KEY_FILE_NONE, &_inner_error0_);
#line 65 "../src/Services/Session.vala"
		_g_free0 (_tmp3_);
#line 65 "../src/Services/Session.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 65 "../src/Services/Session.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 249 "Session.c"
				goto __catch0_g_key_file_error;
			}
#line 65 "../src/Services/Session.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 254 "Session.c"
				goto __catch0_g_file_error;
			}
#line 65 "../src/Services/Session.vala"
			(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 65 "../src/Services/Session.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "../src/Services/Session.vala"
			g_clear_error (&_inner_error0_);
#line 65 "../src/Services/Session.vala"
			return NULL;
#line 265 "Session.c"
		}
#line 66 "../src/Services/Session.vala"
		_tmp4_ = self->priv->key;
#line 66 "../src/Services/Session.vala"
		_tmp6_ = g_key_file_get_groups (_tmp4_, &_tmp5_);
#line 271 "Session.c"
		{
			gchar** group_collection = NULL;
			gint group_collection_length1 = 0;
			gint _group_collection_size_ = 0;
			gint group_it = 0;
#line 66 "../src/Services/Session.vala"
			group_collection = _tmp6_;
#line 66 "../src/Services/Session.vala"
			group_collection_length1 = _tmp5_;
#line 66 "../src/Services/Session.vala"
			for (group_it = 0; group_it < group_collection_length1; group_it = group_it + 1) {
#line 283 "Session.c"
				const gchar* group = NULL;
#line 66 "../src/Services/Session.vala"
				group = group_collection[group_it];
#line 287 "Session.c"
				{
					gchar* _tmp7_ = NULL;
					GKeyFile* _tmp8_;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_ = NULL;
					GKeyFile* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_ = NULL;
					GKeyFile* _tmp16_;
					const gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_ = NULL;
					GKeyFile* _tmp20_;
					const gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_ = NULL;
					GKeyFile* _tmp24_;
					const gchar* _tmp25_;
					gchar* _tmp26_;
					gchar** _tmp27_ = NULL;
					GKeyFile* _tmp28_;
					const gchar* _tmp29_;
					gsize _tmp30_ = 0;
					gchar** _tmp31_;
					gint _tmp27__length1;
					gint __tmp27__size_;
					gchar* _tmp32_ = NULL;
					GKeyFile* _tmp33_;
					const gchar* _tmp34_;
					gchar* _tmp35_;
					gint64 _tmp36_ = 0LL;
					GKeyFile* _tmp37_;
					const gchar* _tmp38_;
					guint64 _tmp39_ = 0ULL;
					GKeyFile* _tmp40_;
					const gchar* _tmp41_;
					gchar* _tmp42_ = NULL;
					GKeyFile* _tmp43_;
					const gchar* _tmp44_;
					gchar* _tmp45_;
					gboolean _tmp46_ = FALSE;
					GKeyFile* _tmp47_;
					const gchar* _tmp48_;
					NotificationsNotification* notification = NULL;
					const gchar* _tmp49_;
					NotificationsNotification* _tmp50_;
					NotificationsNotification* _tmp51_;
					NotificationsNotification* _tmp52_;
#line 69 "../src/Services/Session.vala"
					_tmp8_ = self->priv->key;
#line 69 "../src/Services/Session.vala"
					_tmp9_ = group;
#line 69 "../src/Services/Session.vala"
					_tmp10_ = g_key_file_get_string (_tmp8_, _tmp9_, NOTIFICATIONS_SESSION_APP_NAME_KEY, &_inner_error0_);
#line 69 "../src/Services/Session.vala"
					_tmp7_ = _tmp10_;
#line 69 "../src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 69 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 352 "Session.c"
							goto __catch0_g_key_file_error;
						}
#line 69 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_FILE_ERROR) {
#line 357 "Session.c"
							goto __catch0_g_file_error;
						}
#line 69 "../src/Services/Session.vala"
						(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 69 "../src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 69 "../src/Services/Session.vala"
						g_clear_error (&_inner_error0_);
#line 69 "../src/Services/Session.vala"
						return NULL;
#line 368 "Session.c"
					}
#line 70 "../src/Services/Session.vala"
					_tmp12_ = self->priv->key;
#line 70 "../src/Services/Session.vala"
					_tmp13_ = group;
#line 70 "../src/Services/Session.vala"
					_tmp14_ = g_key_file_get_string (_tmp12_, _tmp13_, NOTIFICATIONS_SESSION_APP_ICON_KEY, &_inner_error0_);
#line 70 "../src/Services/Session.vala"
					_tmp11_ = _tmp14_;
#line 70 "../src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "../src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 70 "../src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 70 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 386 "Session.c"
							goto __catch0_g_key_file_error;
						}
#line 70 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_FILE_ERROR) {
#line 391 "Session.c"
							goto __catch0_g_file_error;
						}
#line 70 "../src/Services/Session.vala"
						(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 70 "../src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 70 "../src/Services/Session.vala"
						g_clear_error (&_inner_error0_);
#line 70 "../src/Services/Session.vala"
						return NULL;
#line 402 "Session.c"
					}
#line 71 "../src/Services/Session.vala"
					_tmp16_ = self->priv->key;
#line 71 "../src/Services/Session.vala"
					_tmp17_ = group;
#line 71 "../src/Services/Session.vala"
					_tmp18_ = g_key_file_get_string (_tmp16_, _tmp17_, NOTIFICATIONS_SESSION_SUMMARY_KEY, &_inner_error0_);
#line 71 "../src/Services/Session.vala"
					_tmp15_ = _tmp18_;
#line 71 "../src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 71 "../src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 71 "../src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 71 "../src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 71 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 422 "Session.c"
							goto __catch0_g_key_file_error;
						}
#line 71 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_FILE_ERROR) {
#line 427 "Session.c"
							goto __catch0_g_file_error;
						}
#line 71 "../src/Services/Session.vala"
						(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 71 "../src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 71 "../src/Services/Session.vala"
						g_clear_error (&_inner_error0_);
#line 71 "../src/Services/Session.vala"
						return NULL;
#line 438 "Session.c"
					}
#line 72 "../src/Services/Session.vala"
					_tmp20_ = self->priv->key;
#line 72 "../src/Services/Session.vala"
					_tmp21_ = group;
#line 72 "../src/Services/Session.vala"
					_tmp22_ = g_key_file_get_string (_tmp20_, _tmp21_, NOTIFICATIONS_SESSION_BODY_KEY, &_inner_error0_);
#line 72 "../src/Services/Session.vala"
					_tmp19_ = _tmp22_;
#line 72 "../src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 72 "../src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 72 "../src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 72 "../src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 72 "../src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 72 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 460 "Session.c"
							goto __catch0_g_key_file_error;
						}
#line 72 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_FILE_ERROR) {
#line 465 "Session.c"
							goto __catch0_g_file_error;
						}
#line 72 "../src/Services/Session.vala"
						(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 72 "../src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 72 "../src/Services/Session.vala"
						g_clear_error (&_inner_error0_);
#line 72 "../src/Services/Session.vala"
						return NULL;
#line 476 "Session.c"
					}
#line 73 "../src/Services/Session.vala"
					_tmp24_ = self->priv->key;
#line 73 "../src/Services/Session.vala"
					_tmp25_ = group;
#line 73 "../src/Services/Session.vala"
					_tmp26_ = g_key_file_get_string (_tmp24_, _tmp25_, NOTIFICATIONS_SESSION_IMAGE_KEY, &_inner_error0_);
#line 73 "../src/Services/Session.vala"
					_tmp23_ = _tmp26_;
#line 73 "../src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 73 "../src/Services/Session.vala"
						_g_free0 (_tmp19_);
#line 73 "../src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 73 "../src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 73 "../src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 73 "../src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 73 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 500 "Session.c"
							goto __catch0_g_key_file_error;
						}
#line 73 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_FILE_ERROR) {
#line 505 "Session.c"
							goto __catch0_g_file_error;
						}
#line 73 "../src/Services/Session.vala"
						(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 73 "../src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 73 "../src/Services/Session.vala"
						g_clear_error (&_inner_error0_);
#line 73 "../src/Services/Session.vala"
						return NULL;
#line 516 "Session.c"
					}
#line 74 "../src/Services/Session.vala"
					_tmp28_ = self->priv->key;
#line 74 "../src/Services/Session.vala"
					_tmp29_ = group;
#line 74 "../src/Services/Session.vala"
					_tmp31_ = g_key_file_get_string_list (_tmp28_, _tmp29_, NOTIFICATIONS_SESSION_ACTIONS_KEY, &_tmp30_, &_inner_error0_);
#line 74 "../src/Services/Session.vala"
					_tmp27_ = _tmp31_;
#line 74 "../src/Services/Session.vala"
					_tmp27__length1 = _tmp30_;
#line 74 "../src/Services/Session.vala"
					__tmp27__size_ = _tmp27__length1;
#line 74 "../src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../src/Services/Session.vala"
						_g_free0 (_tmp23_);
#line 74 "../src/Services/Session.vala"
						_g_free0 (_tmp19_);
#line 74 "../src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 74 "../src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 74 "../src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 74 "../src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 74 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 546 "Session.c"
							goto __catch0_g_key_file_error;
						}
#line 74 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_FILE_ERROR) {
#line 551 "Session.c"
							goto __catch0_g_file_error;
						}
#line 74 "../src/Services/Session.vala"
						(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 74 "../src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 74 "../src/Services/Session.vala"
						g_clear_error (&_inner_error0_);
#line 74 "../src/Services/Session.vala"
						return NULL;
#line 562 "Session.c"
					}
#line 75 "../src/Services/Session.vala"
					_tmp33_ = self->priv->key;
#line 75 "../src/Services/Session.vala"
					_tmp34_ = group;
#line 75 "../src/Services/Session.vala"
					_tmp35_ = g_key_file_get_string (_tmp33_, _tmp34_, NOTIFICATIONS_SESSION_DESKTOP_ID_KEY, &_inner_error0_);
#line 75 "../src/Services/Session.vala"
					_tmp32_ = _tmp35_;
#line 75 "../src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 75 "../src/Services/Session.vala"
						_tmp27_ = (_vala_array_free (_tmp27_, _tmp27__length1, (GDestroyNotify) g_free), NULL);
#line 75 "../src/Services/Session.vala"
						_g_free0 (_tmp23_);
#line 75 "../src/Services/Session.vala"
						_g_free0 (_tmp19_);
#line 75 "../src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 75 "../src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 75 "../src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 75 "../src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 75 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 590 "Session.c"
							goto __catch0_g_key_file_error;
						}
#line 75 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_FILE_ERROR) {
#line 595 "Session.c"
							goto __catch0_g_file_error;
						}
#line 75 "../src/Services/Session.vala"
						(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 75 "../src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 75 "../src/Services/Session.vala"
						g_clear_error (&_inner_error0_);
#line 75 "../src/Services/Session.vala"
						return NULL;
#line 606 "Session.c"
					}
#line 76 "../src/Services/Session.vala"
					_tmp37_ = self->priv->key;
#line 76 "../src/Services/Session.vala"
					_tmp38_ = group;
#line 76 "../src/Services/Session.vala"
					_tmp36_ = g_key_file_get_int64 (_tmp37_, _tmp38_, NOTIFICATIONS_SESSION_UNIX_TIME_KEY, &_inner_error0_);
#line 76 "../src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 76 "../src/Services/Session.vala"
						_g_free0 (_tmp32_);
#line 76 "../src/Services/Session.vala"
						_tmp27_ = (_vala_array_free (_tmp27_, _tmp27__length1, (GDestroyNotify) g_free), NULL);
#line 76 "../src/Services/Session.vala"
						_g_free0 (_tmp23_);
#line 76 "../src/Services/Session.vala"
						_g_free0 (_tmp19_);
#line 76 "../src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 76 "../src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 76 "../src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 76 "../src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 76 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 634 "Session.c"
							goto __catch0_g_key_file_error;
						}
#line 76 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_FILE_ERROR) {
#line 639 "Session.c"
							goto __catch0_g_file_error;
						}
#line 76 "../src/Services/Session.vala"
						(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 76 "../src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 76 "../src/Services/Session.vala"
						g_clear_error (&_inner_error0_);
#line 76 "../src/Services/Session.vala"
						return NULL;
#line 650 "Session.c"
					}
#line 77 "../src/Services/Session.vala"
					_tmp40_ = self->priv->key;
#line 77 "../src/Services/Session.vala"
					_tmp41_ = group;
#line 77 "../src/Services/Session.vala"
					_tmp39_ = g_key_file_get_uint64 (_tmp40_, _tmp41_, NOTIFICATIONS_SESSION_REPLACES_ID_KEY, &_inner_error0_);
#line 77 "../src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../src/Services/Session.vala"
						_g_free0 (_tmp32_);
#line 77 "../src/Services/Session.vala"
						_tmp27_ = (_vala_array_free (_tmp27_, _tmp27__length1, (GDestroyNotify) g_free), NULL);
#line 77 "../src/Services/Session.vala"
						_g_free0 (_tmp23_);
#line 77 "../src/Services/Session.vala"
						_g_free0 (_tmp19_);
#line 77 "../src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 77 "../src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 77 "../src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 77 "../src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 77 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 678 "Session.c"
							goto __catch0_g_key_file_error;
						}
#line 77 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_FILE_ERROR) {
#line 683 "Session.c"
							goto __catch0_g_file_error;
						}
#line 77 "../src/Services/Session.vala"
						(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 77 "../src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 77 "../src/Services/Session.vala"
						g_clear_error (&_inner_error0_);
#line 77 "../src/Services/Session.vala"
						return NULL;
#line 694 "Session.c"
					}
#line 78 "../src/Services/Session.vala"
					_tmp43_ = self->priv->key;
#line 78 "../src/Services/Session.vala"
					_tmp44_ = group;
#line 78 "../src/Services/Session.vala"
					_tmp45_ = g_key_file_get_string (_tmp43_, _tmp44_, NOTIFICATIONS_SESSION_SENDER_KEY, &_inner_error0_);
#line 78 "../src/Services/Session.vala"
					_tmp42_ = _tmp45_;
#line 78 "../src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 78 "../src/Services/Session.vala"
						_g_free0 (_tmp32_);
#line 78 "../src/Services/Session.vala"
						_tmp27_ = (_vala_array_free (_tmp27_, _tmp27__length1, (GDestroyNotify) g_free), NULL);
#line 78 "../src/Services/Session.vala"
						_g_free0 (_tmp23_);
#line 78 "../src/Services/Session.vala"
						_g_free0 (_tmp19_);
#line 78 "../src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 78 "../src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 78 "../src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 78 "../src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 78 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 724 "Session.c"
							goto __catch0_g_key_file_error;
						}
#line 78 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_FILE_ERROR) {
#line 729 "Session.c"
							goto __catch0_g_file_error;
						}
#line 78 "../src/Services/Session.vala"
						(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 78 "../src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 78 "../src/Services/Session.vala"
						g_clear_error (&_inner_error0_);
#line 78 "../src/Services/Session.vala"
						return NULL;
#line 740 "Session.c"
					}
#line 79 "../src/Services/Session.vala"
					_tmp47_ = self->priv->key;
#line 79 "../src/Services/Session.vala"
					_tmp48_ = group;
#line 79 "../src/Services/Session.vala"
					_tmp46_ = g_key_file_get_boolean (_tmp47_, _tmp48_, NOTIFICATIONS_SESSION_HAS_TEMP_FILE_KEY, &_inner_error0_);
#line 79 "../src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "../src/Services/Session.vala"
						_g_free0 (_tmp42_);
#line 79 "../src/Services/Session.vala"
						_g_free0 (_tmp32_);
#line 79 "../src/Services/Session.vala"
						_tmp27_ = (_vala_array_free (_tmp27_, _tmp27__length1, (GDestroyNotify) g_free), NULL);
#line 79 "../src/Services/Session.vala"
						_g_free0 (_tmp23_);
#line 79 "../src/Services/Session.vala"
						_g_free0 (_tmp19_);
#line 79 "../src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 79 "../src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 79 "../src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 79 "../src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 79 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 770 "Session.c"
							goto __catch0_g_key_file_error;
						}
#line 79 "../src/Services/Session.vala"
						if (_inner_error0_->domain == G_FILE_ERROR) {
#line 775 "Session.c"
							goto __catch0_g_file_error;
						}
#line 79 "../src/Services/Session.vala"
						(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 79 "../src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 79 "../src/Services/Session.vala"
						g_clear_error (&_inner_error0_);
#line 79 "../src/Services/Session.vala"
						return NULL;
#line 786 "Session.c"
					}
#line 67 "../src/Services/Session.vala"
					_tmp49_ = group;
#line 67 "../src/Services/Session.vala"
					_tmp50_ = notifications_notification_new (_tmp49_, _tmp7_, _tmp11_, _tmp15_, _tmp19_, _tmp23_, _tmp27_, _tmp27__length1, _tmp32_, _tmp36_, _tmp39_, _tmp42_, _tmp46_);
#line 67 "../src/Services/Session.vala"
					notification = _tmp50_;
#line 81 "../src/Services/Session.vala"
					_tmp51_ = notification;
#line 81 "../src/Services/Session.vala"
					_tmp52_ = _g_object_ref0 (_tmp51_);
#line 81 "../src/Services/Session.vala"
					list = g_list_prepend (list, _tmp52_);
#line 66 "../src/Services/Session.vala"
					_g_object_unref0 (notification);
#line 66 "../src/Services/Session.vala"
					_g_free0 (_tmp42_);
#line 66 "../src/Services/Session.vala"
					_g_free0 (_tmp32_);
#line 66 "../src/Services/Session.vala"
					_tmp27_ = (_vala_array_free (_tmp27_, _tmp27__length1, (GDestroyNotify) g_free), NULL);
#line 66 "../src/Services/Session.vala"
					_g_free0 (_tmp23_);
#line 66 "../src/Services/Session.vala"
					_g_free0 (_tmp19_);
#line 66 "../src/Services/Session.vala"
					_g_free0 (_tmp15_);
#line 66 "../src/Services/Session.vala"
					_g_free0 (_tmp11_);
#line 66 "../src/Services/Session.vala"
					_g_free0 (_tmp7_);
#line 818 "Session.c"
				}
			}
#line 66 "../src/Services/Session.vala"
			group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 823 "Session.c"
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp53_;
		const gchar* _tmp54_;
#line 64 "../src/Services/Session.vala"
		e = _inner_error0_;
#line 64 "../src/Services/Session.vala"
		_inner_error0_ = NULL;
#line 84 "../src/Services/Session.vala"
		_tmp53_ = e;
#line 84 "../src/Services/Session.vala"
		_tmp54_ = _tmp53_->message;
#line 84 "../src/Services/Session.vala"
		g_warning ("Session.vala:84: %s", _tmp54_);
#line 85 "../src/Services/Session.vala"
		notifications_session_create_session_file (self);
#line 64 "../src/Services/Session.vala"
		_g_error_free0 (e);
#line 846 "Session.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp55_;
		const gchar* _tmp56_;
#line 64 "../src/Services/Session.vala"
		e = _inner_error0_;
#line 64 "../src/Services/Session.vala"
		_inner_error0_ = NULL;
#line 87 "../src/Services/Session.vala"
		_tmp55_ = e;
#line 87 "../src/Services/Session.vala"
		_tmp56_ = _tmp55_->message;
#line 87 "../src/Services/Session.vala"
		g_warning ("Session.vala:87: %s", _tmp56_);
#line 64 "../src/Services/Session.vala"
		_g_error_free0 (e);
#line 866 "Session.c"
	}
	__finally0:
#line 64 "../src/Services/Session.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "../src/Services/Session.vala"
		(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 64 "../src/Services/Session.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "../src/Services/Session.vala"
		g_clear_error (&_inner_error0_);
#line 64 "../src/Services/Session.vala"
		return NULL;
#line 879 "Session.c"
	}
#line 90 "../src/Services/Session.vala"
	list = g_list_reverse (list);
#line 91 "../src/Services/Session.vala"
	result = list;
#line 91 "../src/Services/Session.vala"
	return result;
#line 887 "Session.c"
}

void
notifications_session_add_notification (NotificationsSession* self,
                                        NotificationsNotification* notification,
                                        gboolean write_file)
{
	gchar* id = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GKeyFile* _tmp3_;
	const gchar* _tmp4_;
	GDateTime* _tmp5_;
	GKeyFile* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	GKeyFile* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GKeyFile* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	GKeyFile* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	GKeyFile* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GKeyFile* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	GKeyFile* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	GKeyFile* _tmp28_;
	const gchar* _tmp29_;
	gchar** _tmp30_;
	gint _tmp30__length1;
	GKeyFile* _tmp31_;
	const gchar* _tmp32_;
	GKeyFile* _tmp33_;
	const gchar* _tmp34_;
#line 94 "../src/Services/Session.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/Services/Session.vala"
	g_return_if_fail (notification != NULL);
#line 95 "../src/Services/Session.vala"
	_tmp0_ = notifications_notification_get_internal_id (notification);
#line 95 "../src/Services/Session.vala"
	_tmp1_ = _tmp0_;
#line 95 "../src/Services/Session.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 95 "../src/Services/Session.vala"
	id = _tmp2_;
#line 96 "../src/Services/Session.vala"
	_tmp3_ = self->priv->key;
#line 96 "../src/Services/Session.vala"
	_tmp4_ = id;
#line 96 "../src/Services/Session.vala"
	_tmp5_ = notification->timestamp;
#line 96 "../src/Services/Session.vala"
	g_key_file_set_int64 (_tmp3_, _tmp4_, NOTIFICATIONS_SESSION_UNIX_TIME_KEY, g_date_time_to_unix (_tmp5_));
#line 97 "../src/Services/Session.vala"
	_tmp6_ = self->priv->key;
#line 97 "../src/Services/Session.vala"
	_tmp7_ = id;
#line 97 "../src/Services/Session.vala"
	_tmp8_ = notification->app_icon;
#line 97 "../src/Services/Session.vala"
	g_key_file_set_string (_tmp6_, _tmp7_, NOTIFICATIONS_SESSION_APP_ICON_KEY, _tmp8_);
#line 98 "../src/Services/Session.vala"
	_tmp9_ = self->priv->key;
#line 98 "../src/Services/Session.vala"
	_tmp10_ = id;
#line 98 "../src/Services/Session.vala"
	_tmp11_ = notification->app_name;
#line 98 "../src/Services/Session.vala"
	g_key_file_set_string (_tmp9_, _tmp10_, NOTIFICATIONS_SESSION_APP_NAME_KEY, _tmp11_);
#line 99 "../src/Services/Session.vala"
	_tmp12_ = self->priv->key;
#line 99 "../src/Services/Session.vala"
	_tmp13_ = id;
#line 99 "../src/Services/Session.vala"
	_tmp14_ = notification->message_body;
#line 99 "../src/Services/Session.vala"
	g_key_file_set_string (_tmp12_, _tmp13_, NOTIFICATIONS_SESSION_BODY_KEY, _tmp14_);
#line 100 "../src/Services/Session.vala"
	_tmp15_ = self->priv->key;
#line 100 "../src/Services/Session.vala"
	_tmp16_ = id;
#line 100 "../src/Services/Session.vala"
	_tmp17_ = notifications_notification_get_image_path (notification);
#line 100 "../src/Services/Session.vala"
	_tmp18_ = _tmp17_;
#line 100 "../src/Services/Session.vala"
	g_key_file_set_string (_tmp15_, _tmp16_, NOTIFICATIONS_SESSION_IMAGE_KEY, _tmp18_);
#line 101 "../src/Services/Session.vala"
	_tmp19_ = self->priv->key;
#line 101 "../src/Services/Session.vala"
	_tmp20_ = id;
#line 101 "../src/Services/Session.vala"
	_tmp21_ = notification->desktop_id;
#line 101 "../src/Services/Session.vala"
	g_key_file_set_string (_tmp19_, _tmp20_, NOTIFICATIONS_SESSION_DESKTOP_ID_KEY, _tmp21_);
#line 102 "../src/Services/Session.vala"
	_tmp22_ = self->priv->key;
#line 102 "../src/Services/Session.vala"
	_tmp23_ = id;
#line 102 "../src/Services/Session.vala"
	_tmp24_ = notification->sender;
#line 102 "../src/Services/Session.vala"
	g_key_file_set_string (_tmp22_, _tmp23_, NOTIFICATIONS_SESSION_SENDER_KEY, _tmp24_);
#line 103 "../src/Services/Session.vala"
	_tmp25_ = self->priv->key;
#line 103 "../src/Services/Session.vala"
	_tmp26_ = id;
#line 103 "../src/Services/Session.vala"
	_tmp27_ = notification->summary;
#line 103 "../src/Services/Session.vala"
	g_key_file_set_string (_tmp25_, _tmp26_, NOTIFICATIONS_SESSION_SUMMARY_KEY, _tmp27_);
#line 104 "../src/Services/Session.vala"
	_tmp28_ = self->priv->key;
#line 104 "../src/Services/Session.vala"
	_tmp29_ = id;
#line 104 "../src/Services/Session.vala"
	_tmp30_ = notification->actions;
#line 104 "../src/Services/Session.vala"
	_tmp30__length1 = notification->actions_length1;
#line 104 "../src/Services/Session.vala"
	g_key_file_set_string_list (_tmp28_, _tmp29_, NOTIFICATIONS_SESSION_ACTIONS_KEY, (const gchar* const*) _tmp30_, (gint) _tmp30__length1);
#line 105 "../src/Services/Session.vala"
	_tmp31_ = self->priv->key;
#line 105 "../src/Services/Session.vala"
	_tmp32_ = id;
#line 105 "../src/Services/Session.vala"
	g_key_file_set_uint64 (_tmp31_, _tmp32_, NOTIFICATIONS_SESSION_REPLACES_ID_KEY, (guint64) notification->replaces_id);
#line 106 "../src/Services/Session.vala"
	_tmp33_ = self->priv->key;
#line 106 "../src/Services/Session.vala"
	_tmp34_ = id;
#line 106 "../src/Services/Session.vala"
	g_key_file_set_boolean (_tmp33_, _tmp34_, NOTIFICATIONS_SESSION_HAS_TEMP_FILE_KEY, notification->has_temp_file);
#line 108 "../src/Services/Session.vala"
	if (write_file) {
#line 109 "../src/Services/Session.vala"
		notifications_session_write_contents (self);
#line 1036 "Session.c"
	}
#line 94 "../src/Services/Session.vala"
	_g_free0 (id);
#line 1040 "Session.c"
}

void
notifications_session_remove_notification (NotificationsSession* self,
                                           NotificationsNotification* notification,
                                           gboolean write_file)
{
	GError* _inner_error0_ = NULL;
#line 113 "../src/Services/Session.vala"
	g_return_if_fail (self != NULL);
#line 113 "../src/Services/Session.vala"
	g_return_if_fail (notification != NULL);
#line 1053 "Session.c"
	{
		GKeyFile* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
#line 115 "../src/Services/Session.vala"
		if (notification->has_temp_file) {
#line 1060 "Session.c"
			GFile* file = NULL;
			const gchar* _tmp0_;
			const gchar* _tmp1_;
			GFile* _tmp2_;
#line 116 "../src/Services/Session.vala"
			_tmp0_ = notifications_notification_get_image_path (notification);
#line 116 "../src/Services/Session.vala"
			_tmp1_ = _tmp0_;
#line 116 "../src/Services/Session.vala"
			_tmp2_ = g_file_new_for_path (_tmp1_);
#line 116 "../src/Services/Session.vala"
			file = _tmp2_;
#line 1073 "Session.c"
			{
				GFile* _tmp3_;
#line 118 "../src/Services/Session.vala"
				_tmp3_ = file;
#line 118 "../src/Services/Session.vala"
				g_file_delete (_tmp3_, NULL, &_inner_error0_);
#line 118 "../src/Services/Session.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1082 "Session.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				const gchar* _tmp4_;
				const gchar* _tmp5_;
#line 117 "../src/Services/Session.vala"
				g_clear_error (&_inner_error0_);
#line 120 "../src/Services/Session.vala"
				_tmp4_ = notifications_notification_get_image_path (notification);
#line 120 "../src/Services/Session.vala"
				_tmp5_ = _tmp4_;
#line 120 "../src/Services/Session.vala"
				g_critical ("Session.vala:120: Unable to delete tmpfile: %s", _tmp5_);
#line 1099 "Session.c"
			}
			__finally1:
#line 117 "../src/Services/Session.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 117 "../src/Services/Session.vala"
				_g_object_unref0 (file);
#line 117 "../src/Services/Session.vala"
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1108 "Session.c"
					goto __catch0_g_key_file_error;
				}
#line 117 "../src/Services/Session.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 117 "../src/Services/Session.vala"
				g_clear_error (&_inner_error0_);
#line 117 "../src/Services/Session.vala"
				return;
#line 1117 "Session.c"
			}
#line 115 "../src/Services/Session.vala"
			_g_object_unref0 (file);
#line 1121 "Session.c"
		}
#line 123 "../src/Services/Session.vala"
		_tmp6_ = self->priv->key;
#line 123 "../src/Services/Session.vala"
		_tmp7_ = notifications_notification_get_internal_id (notification);
#line 123 "../src/Services/Session.vala"
		_tmp8_ = _tmp7_;
#line 123 "../src/Services/Session.vala"
		g_key_file_remove_group (_tmp6_, _tmp8_, &_inner_error0_);
#line 123 "../src/Services/Session.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 123 "../src/Services/Session.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1135 "Session.c"
				goto __catch0_g_key_file_error;
			}
#line 123 "../src/Services/Session.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 123 "../src/Services/Session.vala"
			g_clear_error (&_inner_error0_);
#line 123 "../src/Services/Session.vala"
			return;
#line 1144 "Session.c"
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 114 "../src/Services/Session.vala"
		e = _inner_error0_;
#line 114 "../src/Services/Session.vala"
		_inner_error0_ = NULL;
#line 125 "../src/Services/Session.vala"
		_tmp9_ = e;
#line 125 "../src/Services/Session.vala"
		_tmp10_ = _tmp9_->message;
#line 125 "../src/Services/Session.vala"
		g_warning ("Session.vala:125: %s", _tmp10_);
#line 114 "../src/Services/Session.vala"
		_g_error_free0 (e);
#line 1165 "Session.c"
	}
	__finally0:
#line 114 "../src/Services/Session.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 114 "../src/Services/Session.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 114 "../src/Services/Session.vala"
		g_clear_error (&_inner_error0_);
#line 114 "../src/Services/Session.vala"
		return;
#line 1176 "Session.c"
	}
#line 128 "../src/Services/Session.vala"
	if (write_file) {
#line 129 "../src/Services/Session.vala"
		notifications_session_write_contents (self);
#line 1182 "Session.c"
	}
}

void
notifications_session_remove_notifications (NotificationsSession* self,
                                            NotificationsNotification** notifications,
                                            gint notifications_length1)
{
#line 133 "../src/Services/Session.vala"
	g_return_if_fail (self != NULL);
#line 1193 "Session.c"
	{
		NotificationsNotification** notification_collection = NULL;
		gint notification_collection_length1 = 0;
		gint _notification_collection_size_ = 0;
		gint notification_it = 0;
#line 134 "../src/Services/Session.vala"
		notification_collection = notifications;
#line 134 "../src/Services/Session.vala"
		notification_collection_length1 = notifications_length1;
#line 134 "../src/Services/Session.vala"
		for (notification_it = 0; notification_it < notification_collection_length1; notification_it = notification_it + 1) {
#line 1205 "Session.c"
			NotificationsNotification* notification = NULL;
#line 134 "../src/Services/Session.vala"
			notification = notification_collection[notification_it];
#line 1209 "Session.c"
			{
				NotificationsNotification* _tmp0_;
#line 135 "../src/Services/Session.vala"
				_tmp0_ = notification;
#line 135 "../src/Services/Session.vala"
				notifications_session_remove_notification (self, _tmp0_, FALSE);
#line 1216 "Session.c"
			}
		}
	}
#line 138 "../src/Services/Session.vala"
	notifications_session_write_contents (self);
#line 1222 "Session.c"
}

void
notifications_session_clear (NotificationsSession* self)
{
	GError* _inner_error0_ = NULL;
#line 141 "../src/Services/Session.vala"
	g_return_if_fail (self != NULL);
#line 1231 "Session.c"
	{
		GFile* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 143 "../src/Services/Session.vala"
		_tmp0_ = self->priv->session_file;
#line 143 "../src/Services/Session.vala"
		_tmp1_ = g_file_get_path (_tmp0_);
#line 143 "../src/Services/Session.vala"
		_tmp2_ = _tmp1_;
#line 143 "../src/Services/Session.vala"
		g_file_set_contents (_tmp2_, "", (gssize) -1, &_inner_error0_);
#line 143 "../src/Services/Session.vala"
		_g_free0 (_tmp2_);
#line 143 "../src/Services/Session.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 143 "../src/Services/Session.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1250 "Session.c"
				goto __catch0_g_file_error;
			}
#line 143 "../src/Services/Session.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 143 "../src/Services/Session.vala"
			g_clear_error (&_inner_error0_);
#line 143 "../src/Services/Session.vala"
			return;
#line 1259 "Session.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 142 "../src/Services/Session.vala"
		e = _inner_error0_;
#line 142 "../src/Services/Session.vala"
		_inner_error0_ = NULL;
#line 145 "../src/Services/Session.vala"
		_tmp3_ = e;
#line 145 "../src/Services/Session.vala"
		_tmp4_ = _tmp3_->message;
#line 145 "../src/Services/Session.vala"
		g_warning ("Session.vala:145: %s", _tmp4_);
#line 142 "../src/Services/Session.vala"
		_g_error_free0 (e);
#line 1280 "Session.c"
	}
	__finally0:
#line 142 "../src/Services/Session.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 142 "../src/Services/Session.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 142 "../src/Services/Session.vala"
		g_clear_error (&_inner_error0_);
#line 142 "../src/Services/Session.vala"
		return;
#line 1291 "Session.c"
	}
}

static void
notifications_session_create_session_file (NotificationsSession* self)
{
	GError* _inner_error0_ = NULL;
#line 149 "../src/Services/Session.vala"
	g_return_if_fail (self != NULL);
#line 1301 "Session.c"
	{
		GFile* _tmp0_;
		GFileOutputStream* _tmp1_;
		GFileOutputStream* _tmp2_;
#line 151 "../src/Services/Session.vala"
		_tmp0_ = self->priv->session_file;
#line 151 "../src/Services/Session.vala"
		_tmp1_ = g_file_create (_tmp0_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error0_);
#line 151 "../src/Services/Session.vala"
		_tmp2_ = _tmp1_;
#line 151 "../src/Services/Session.vala"
		_g_object_unref0 (_tmp2_);
#line 151 "../src/Services/Session.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1316 "Session.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 150 "../src/Services/Session.vala"
		e = _inner_error0_;
#line 150 "../src/Services/Session.vala"
		_inner_error0_ = NULL;
#line 153 "../src/Services/Session.vala"
		_tmp3_ = e;
#line 153 "../src/Services/Session.vala"
		_tmp4_ = _tmp3_->message;
#line 153 "../src/Services/Session.vala"
		g_warning ("Session.vala:153: %s", _tmp4_);
#line 150 "../src/Services/Session.vala"
		_g_error_free0 (e);
#line 1338 "Session.c"
	}
	__finally0:
#line 150 "../src/Services/Session.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 150 "../src/Services/Session.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 150 "../src/Services/Session.vala"
		g_clear_error (&_inner_error0_);
#line 150 "../src/Services/Session.vala"
		return;
#line 1349 "Session.c"
	}
}

static gboolean
__lambda11_ (NotificationsSession* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 164 "../src/Services/Session.vala"
	self->priv->write_timeout_id = (guint) 0;
#line 1360 "Session.c"
	{
		GFile* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GKeyFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 166 "../src/Services/Session.vala"
		_tmp0_ = self->priv->session_file;
#line 166 "../src/Services/Session.vala"
		_tmp1_ = g_file_get_path (_tmp0_);
#line 166 "../src/Services/Session.vala"
		_tmp2_ = _tmp1_;
#line 166 "../src/Services/Session.vala"
		_tmp3_ = self->priv->key;
#line 166 "../src/Services/Session.vala"
		_tmp4_ = g_key_file_to_data (_tmp3_, NULL, NULL);
#line 166 "../src/Services/Session.vala"
		_tmp5_ = _tmp4_;
#line 166 "../src/Services/Session.vala"
		g_file_set_contents (_tmp2_, _tmp5_, (gssize) -1, &_inner_error0_);
#line 166 "../src/Services/Session.vala"
		_g_free0 (_tmp5_);
#line 166 "../src/Services/Session.vala"
		_g_free0 (_tmp2_);
#line 166 "../src/Services/Session.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1388 "Session.c"
			gboolean _tmp6_ = FALSE;
#line 166 "../src/Services/Session.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1392 "Session.c"
				goto __catch0_g_file_error;
			}
#line 166 "../src/Services/Session.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 166 "../src/Services/Session.vala"
			g_clear_error (&_inner_error0_);
#line 166 "../src/Services/Session.vala"
			return _tmp6_;
#line 1401 "Session.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 165 "../src/Services/Session.vala"
		e = _inner_error0_;
#line 165 "../src/Services/Session.vala"
		_inner_error0_ = NULL;
#line 168 "../src/Services/Session.vala"
		_tmp7_ = e;
#line 168 "../src/Services/Session.vala"
		_tmp8_ = _tmp7_->message;
#line 168 "../src/Services/Session.vala"
		g_warning ("Session.vala:168: %s", _tmp8_);
#line 165 "../src/Services/Session.vala"
		_g_error_free0 (e);
#line 1422 "Session.c"
	}
	__finally0:
#line 165 "../src/Services/Session.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1427 "Session.c"
		gboolean _tmp9_ = FALSE;
#line 165 "../src/Services/Session.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 165 "../src/Services/Session.vala"
		g_clear_error (&_inner_error0_);
#line 165 "../src/Services/Session.vala"
		return _tmp9_;
#line 1435 "Session.c"
	}
#line 171 "../src/Services/Session.vala"
	result = G_SOURCE_REMOVE;
#line 171 "../src/Services/Session.vala"
	return result;
#line 1441 "Session.c"
}

static gboolean
___lambda11__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda11_ ((NotificationsSession*) self);
#line 163 "../src/Services/Session.vala"
	return result;
#line 1451 "Session.c"
}

static void
notifications_session_write_contents (NotificationsSession* self)
{
#line 158 "../src/Services/Session.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/Services/Session.vala"
	if (self->priv->write_timeout_id > ((guint) 0)) {
#line 160 "../src/Services/Session.vala"
		g_source_remove (self->priv->write_timeout_id);
#line 1463 "Session.c"
	}
#line 163 "../src/Services/Session.vala"
	self->priv->write_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ___lambda11__gsource_func, g_object_ref (self), g_object_unref);
#line 1467 "Session.c"
}

static void
notifications_session_class_init (NotificationsSessionClass * klass,
                                  gpointer klass_data)
{
#line 24 "../src/Services/Session.vala"
	notifications_session_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Services/Session.vala"
	g_type_class_adjust_private_offset (klass, &NotificationsSession_private_offset);
#line 24 "../src/Services/Session.vala"
	G_OBJECT_CLASS (klass)->finalize = notifications_session_finalize;
#line 1480 "Session.c"
}

static void
notifications_session_instance_init (NotificationsSession * self,
                                     gpointer klass)
{
#line 24 "../src/Services/Session.vala"
	self->priv = notifications_session_get_instance_private (self);
#line 28 "../src/Services/Session.vala"
	self->priv->session_file = NULL;
#line 157 "../src/Services/Session.vala"
	self->priv->write_timeout_id = (guint) 0;
#line 1493 "Session.c"
}

static void
notifications_session_finalize (GObject * obj)
{
	NotificationsSession * self;
#line 24 "../src/Services/Session.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOTIFICATIONS_TYPE_SESSION, NotificationsSession);
#line 28 "../src/Services/Session.vala"
	_g_object_unref0 (self->priv->session_file);
#line 42 "../src/Services/Session.vala"
	_g_key_file_unref0 (self->priv->key);
#line 24 "../src/Services/Session.vala"
	G_OBJECT_CLASS (notifications_session_parent_class)->finalize (obj);
#line 1508 "Session.c"
}

static GType
notifications_session_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NotificationsSessionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notifications_session_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotificationsSession), 0, (GInstanceInitFunc) notifications_session_instance_init, NULL };
	GType notifications_session_type_id;
	notifications_session_type_id = g_type_register_static (G_TYPE_OBJECT, "NotificationsSession", &g_define_type_info, 0);
	NotificationsSession_private_offset = g_type_add_instance_private (notifications_session_type_id, sizeof (NotificationsSessionPrivate));
	return notifications_session_type_id;
}

GType
notifications_session_get_type (void)
{
	static volatile gsize notifications_session_type_id__once = 0;
	if (g_once_init_enter (&notifications_session_type_id__once)) {
		GType notifications_session_type_id;
		notifications_session_type_id = notifications_session_get_type_once ();
		g_once_init_leave (&notifications_session_type_id__once, notifications_session_type_id);
	}
	return notifications_session_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

